//$Id: foo_arc.c,v 1.1 2009-03-25 19:11:56 syan Exp $
//$Source: /cvs2hg/rsync/cvs/jaguar/u-boot-1.1.3/arc0fm/foo_arc.c,v $


//#include "libArc.h"     // libdv function declarations
#include "reg_header.h"  // mm reg offset

void RegWriteD(unsigned long addr, unsigned long value)
{
    volatile unsigned long *mem_addr;
    mem_addr = (volatile unsigned long *) addr;
    *mem_addr = value;

}
unsigned long getRegValueD(unsigned long addr)
{
    volatile unsigned long *mem_addr;
    mem_addr = (volatile unsigned long *) addr;
    return *mem_addr;
}

#if 0
void enableInt1(void)
{
	_flag(0x02);
	return;
}
void enableInt2(void)
{
	_flag(0x04);
	return;
}
void enableInt12(void)
{
	_flag(0x06);
	return;
}
#endif

#define AUX_IRQ_LV12 (0x43)

void clearInt1(void)
{
	_sr(0x1, AUX_IRQ_LV12);
}

void clearInt2(void)
{
	_sr(0x2, AUX_IRQ_LV12);
}

void clearInt12(void)
{
	_sr(0x3, AUX_IRQ_LV12);
}

unsigned long procBase;
unsigned long 
main(unsigned long regBaseAdr, unsigned long cachedFbBaseAdr, unsigned long procRegBase)
{
	unsigned long read = 0;
	int count=0, finish = 0;
	unsigned char *srcAddr = (unsigned char *)0x10000, *targetAddr=(unsigned char *)0x1000;
	unsigned long length=0x8, temp = 0;
	unsigned long read1 =0;

    read = getRegValueD(CG_RESET_REG+regBaseAdr); // make sure proc4 is not in reset - bootguard will put him in reset at the end
    RegWriteD(CG_RESET_REG+regBaseAdr, read & (~PROC4_RESET_MASK));

    // poll for DMA done interrupt
    do
    {
      read = getRegValueD(DMA_MIPS_INT_STATUS+regBaseAdr); 
	  read1= getRegValueD(0x00fc+regBaseAdr);	
	} while ((read == 0)&& (read1 != 0xdeadbeef));
    read = 0;

    // clear DMA done interrupt and place dma in reset
    RegWriteD(DMA_MIPS_INT_STATUS+regBaseAdr, 0xf);
    read = getRegValueD(CG_RESET_REG+regBaseAdr); // write it in int8
    RegWriteD(CG_RESET_REG+regBaseAdr, read | DMA_RESET_MASK);

	read = getRegValueD(CG_RESET_REG + regBaseAdr); // write it in int8
	RegWriteD(CG_RESET_REG + regBaseAdr, read | PROC4_RESET_MASK);

    // poll for proc4 in reset - this signifies the end of secure mode
    do
    {
      read = getRegValueD(CG_RESET_REG+regBaseAdr); // write it in int8
      read = read & PROC4_RESET_MASK;
    } while (read == 0);

	//Reset proc4
	temp = getRegValueD(CG_RESET_REG+regBaseAdr);
//	temp |= 0x00400000;
//	RegWriteD(CG_RESET_REG+regBaseAdr, temp);

//	temp &= ~0x00400000;
	RegWriteD(CG_RESET_REG+regBaseAdr, 0x0);

	RegWriteD(PROC4_RST+regBaseAdr, 0);

	RegWriteD(PROC4_FB_TOP+regBaseAdr, 0xc000000);


//	RegWriteD(PROC4_MMREG_APER, 0x1fff1000);

//	RegWriteD(PROC4_MERGED_WRITE_CTL,0x00000100);

	//Do uboot vertor table transfer from 0x40000 to 0x1000
	while(length > 0)
	{
		*targetAddr = *srcAddr;
		targetAddr++;
		srcAddr++;
		length--;
	}
	
	//take proc4 out of reset
	RegWriteD(PROC4_RST+regBaseAdr, 1);

		while(1);
	return 0;
}



_Interrupt1 void  
isr8(void)
{
	unsigned int read = 0;
	unsigned int readback = 0;
	
	read = getRegValueD(PROC_PROC_INT_STATUS+procBase);
	
	if(read==PROC_PROC_INT_STATUS_INBOUND_CALL0_MASK)
	{
		RegWriteD(PROC_MSG_DATA_3+procBase, 0xaaaaaaaa);
	}
	else if (read==PROC_PROC_INT_STATUS_INBOUND_CALL1_MASK)
	{
		RegWriteD(PROC_MSG_DATA_3+procBase, 0xbbbbbbbb);
	}
	else if (read==PROC_PROC_INT_STATUS_DBG_INBOUND0_MASK)
	{
		RegWriteD(PROC_MSG_DATA_3+procBase, 0xcccccccc);
	}
	else if (read==PROC_PROC_INT_STATUS_DBG_INBOUND1_MASK)
	{
		RegWriteD(PROC_MSG_DATA_3+procBase, 0xdddddddd);
	}
	else if (read==PROC_PROC_INT_STATUS_DBG_INBOUND2_MASK)
	{
		RegWriteD(PROC_MSG_DATA_3+procBase, 0xeeeeeeee);
	}
	else if (read==PROC_PROC_INT_STATUS_DBG_INBOUND3_MASK)
	{
		RegWriteD(PROC_MSG_DATA_3+procBase, 0xffffffff);
	}
	else if (read==PROC_PROC_INT_STATUS_DBG_INBOUND4_MASK)
	{
		RegWriteD(PROC_MSG_DATA_3+procBase, 0x0000abcd);
	}
	else 
	{
		RegWriteD(PROC_MSG_DATA_3+procBase, 0xdead0abc);
	}
	
	/*write 1 to clear*/
	RegWriteD(PROC_PROC_INT_STATUS+procBase, read);
	
	while(1)
	{
		readback = getRegValueD(PROC_PROC_INT_STATUS +procBase);// make sure the write has happened 
		if(readback == 0)
		   break;
	}

	RegWriteD(PROC_MSG_DATA_5+procBase, read);

	// notify a new interrupt has happened
	RegWriteD(PROC_MSG_DATA_6+procBase, 0x12345678);
	
	clearInt1();
	
	return;
}

//extern void wrong(void);

_Interrupt2 void  
memIsr(void){
	//wrong();
	_ASM("    jal wrong");
} 
      
_Interrupt2 void  
insErrIsr(void){
	_ASM("    jal wrong");
} 

_Interrupt1 void  
timer0Isr(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
timer1Isr(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
uartIsr(void){
	_ASM("    jal wrong");
} 
      
_Interrupt1 void  
emacIsr(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr7(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr9(void){
	_ASM("    jal wrong");
} 

_Interrupt1 void  
isr10(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr11(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr12(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr13(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr14(void){
	_ASM("    jal wrong");
}
  
_Interrupt1 void  
isr15(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr16(void){
	_ASM("    jal wrong");
}

_Interrupt1 void  
isr17(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr18(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr19(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr20(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr21(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr22(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr23(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr24(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr25(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr26(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr27(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr28(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr29(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr30(void){
	_ASM("    jal wrong");
}
 
_Interrupt1 void  
isr31(void){
	_ASM("    jal wrong");
}
void
ev_machineCheck(void){
	_ASM("    jal wrong");
}

void
ev_TLBMissI(void){
	_ASM("    jal wrong");
}

void
ev_TLBMissD(void){
	_ASM("    jal wrong");
}

void
ev_TLBProtV(void){
	_ASM("    jal wrong");
}

void
ev_PrivilegeV(void){
	_ASM("    jal wrong");
}

void
ev_Trap(void){
	_ASM("    jal wrong");
}

void
ev_Extension(void){
	_ASM("    jal wrong");
}
 

//$Log: not supported by cvs2svn $
//Revision 1.8  2007/10/18 20:50:25  jzhang
//check write result in the end of ISR to make sure the interrupt has been cleaned, thus no re-entry of the interrupt
//
//Revision 1.7  2007/09/07 19:52:11  jzhang
//panther update
//
//Revision 1.6  2007/05/03 20:57:47  jzhang
//adjust to suit ARC_OPT=DISABLE_CACHE
//
//Revision 1.5  2007/04/17 18:04:51  jzhang
//fix race condition
//
//Revision 1.4  2007/04/02 21:33:01  jzhang
//add dbg_inbound0-4
//
//Revision 1.3  2007/03/30 21:02:29  jzhang
//add dbg_inbound0-4
//
//Revision 1.2  2007/01/29 21:19:38  jzhang
//fixed race condition
//
//Revision 1.1  2006/10/06 19:50:46  gwang
//test for inbound interrupts
//
//Revision 1.1  2006/08/29 16:23:51  gwang
//add more testcases for proc0 and delete testcase quick
//

