/******************************************************************************
 * Copyright Codito Technologies (www.codito.com) Aug 17 , 2005
 * 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 *****************************************************************************/

/*
 *  uboot/board/aa3/aa3.c
 *
 *  Copyright (C) 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 * 
 * Authors : Sandeep Patil and Pradeep Sawlani.
 */

#include <asm/arcregs.h>

#include <linux/types.h>
#include <config.h>
#include <asm/global_data.h>	/* For global data structre */


#define TIMER0_LIMIT 0xffffffff         /* Maximum limit for timer      */

static ulong timestamp;

/*      Function to start timer from 'count'    */

void set_timer (ulong count)
{

	        /*      Set up the LIMIT0 , COUNT0 and CONTROL0 registers for timer 0  without interrupt	*/
	
		        write_new_aux_reg(ARC_REG_TIMER0_LIMIT,TIMER0_LIMIT);
		        write_new_aux_reg(ARC_REG_TIMER0_CNT,count);
			write_new_aux_reg(ARC_REG_TIMER0_CTRL,2);

		        return;
}

/*      Function to get the current count value         */

ulong get_timer (ulong base)
{

	        /* Read the count value from COUNT0     */

			timestamp = read_new_aux_reg(ARC_REG_TIMER0_CNT);

		        return (timestamp - base);
}


void reset_timer (void)
{
		        set_timer(0);

		        return;

}

/*      Delay function  */

void udelay (unsigned long usec)
{
    ulong uTicks;
    unsigned char *temp;
    temp = getenv("clockspeed");
    set_timer(0);
    if(temp)
        uTicks = (simple_strtoul(temp,NULL,10)/1000000) * usec;    
    else
        uTicks = (CONFIG_ARC_CLK/1000000) * usec;
    /* Continue looping till the timer count is more thean the required delay	*/
    while(get_timer(0) < uTicks); 
}

int board_init(void)
{
        DECLARE_GLOBAL_DATA_PTR;
	
	
	reset_timer();	/* Intialise the timer */
	
	//gd->bd->bi_boot_params = TEXT_BASE - CFG_MALLOC_LEN + CFG_ENV_SIZE; /* address of kernel parameters */
	//gd->bd->bi_boot_params = TEXT_BASE + CFG_UBOOT_SIZE + CFG_MALLOC_LEN - CFG_ENV_SIZE; /* address of kernel parameters */
	gd->bd->bi_boot_params = TEXT_BASE + CFG_UBOOT_SIZE + CFG_MALLOC_LEN - CFG_ENV_SIZE; /* address of kernel parameters */
	return (0);
}
