#include <common.h>
#include <command.h>
#include <hush.h> 
#if (CONFIG_COMMANDS & CFG_CMD_MMC)
#include <mmc.h>
#endif
#ifdef CONFIG_HAS_DATAFLASH
#include <dataflash.h>
#endif
#include "uui.h"


// ****************************************************************************************
// ****************************************************************************************

#define DS_DMA_Lcl2Sd(a,b,c) SDMAToSD((void*)a,(void*)b,c);
#define NUM_PATTERNS 11
#define NUM_TRAIL 1
#define sso_test_base_0 30*1024*1024
#define MAX_MEM 256*1024*1024
#define SSO_BUFF (10*1024*1024)

static unsigned long  mem_data_array[512];
static unsigned long  mem_read_array[512];
int mem_result_array[2][NUM_PATTERNS][16];
unsigned char line[1024];
unsigned int sso_test_base;
unsigned int sso_test_end;
unsigned int num_trail;
unsigned int __select_bit;
unsigned int __high_or_low;
void etc_buffer_read(unsigned long * read_buffer,unsigned long addr);
void etc_buffer_write(unsigned long * write_buffer,unsigned long addr);
extern long * buffer ;
void etc_ddr_dma_test(void);
/*extern BERR_Code TEST_XVD_DmaFrameBuffers(
	BCHP_Handle      hChp, 
	BREG_Handle      hReg, 
	BMEM_Handle      hMem, 
	BINT_Handle      hInt, 
	BMEM_Handle      hSrcMem, 
	unsigned char   *pBufSrc, 
	BMEM_Handle      hDstMem, 
	unsigned char   *pBufDst, 
	uint32_t         ulNumBytes );
*/

// ****************************************************************************************
// *                             Main DDR Test Menu                                       *
// * Prints out the main menu for DDDR tests and gets user choice                         *
// * Inputs:   none                                                                       *
// * Outputs:  The number of the test to perform                                          *
// *                                                                                      *
// ****************************************************************************************
extern int readline (const char *const prompt);
extern char console_buffer[];		/* console I/O buffer	*/

void etcDDR_SSOTest(void)
{
  int command_id;
  unsigned char done = 0;
  char str[CFG_CBSIZE];
  int temp_dqs;
  unsigned char dqs_value;
  static unsigned long int_val;
  static int choice;
  int len;

  while (!done)
  {
     printf("\n\n-----DDR Tests and Utilities Menu-----");
     printf("\nsso_test_base:%x sso_test_end:%x",sso_test_base,sso_test_end);
     printf("\nnumber of trail:%d\n",num_trail);
     printf("\nselect_bit:%d high_or_low:%d\n",__select_bit,__high_or_low);
     printf("\n 0)  Exit");
     printf("\n 1)  System SSO standard");
     printf("\n 2)  System SSO 1 bit static WRITE");
     printf("\n 3)  System SSO 1 bit static READ");
     printf("\n 4)  System SSO 1 bit out of phase WRITE");
     printf("\n 5)  System SSO 1 bit out of phase READ");
     printf("\n 6)  Decode SSO standard");
     printf("\n 7)  Decode SSO 1 bit static WRITE");
     printf("\n 8)  Decode SSO 1 bit static READ");
     printf("\n 9)  Decode SSO 1 bit out of phase WRITE");
     printf("\n 10) Decode SSO 1 bit out of phase READ");
//     printf("\n 11) Change System DDR Settings");
//     printf("\n 12) MemTest86");
     printf("\n 13) walking one");
     printf("\n 14) walking zero");
     printf("\n 15) address and data bus");
     printf("\n 16) all test");
     printf("\n 20) change setting");
     printf("\n Choice and enter: ");

     //get the user input.  Will wait for remote or keyboard input
     len=readline(NULL);
     strcpy(str,console_buffer);
     choice=simple_strtoul(str,NULL,10);
     
     printf("choice:%d\n",choice);
     switch (choice)
      {
         case 20:
              etc_system_change();
              break;
         case 16:
              etc_system_all_test(); 
              break;
         case 0:
              done = 1;
              break;

         case 1:
              etc_system_sso_test();
              break;

         case 2:
    	      etc_system_static_write_test();
              //clear_status_screen ();
              break;

         case 3:
              etc_system_static_read_test();
              //clear_status_screen ();
              break;

         case 4:
              etc_system_phase_write_test();
              //clear_status_screen ();
              break;

         case 5:
              etc_system_phase_read_test();
              //clear_status_screen ();
              break;

         case 6:
              etc_decode_sso_test();
              //clear_status_screen ();
              break;

         case 7:
	      etc_decode_static_write_test();
              //clear_status_screen ();
              break;

         case 8:
              etc_decode_static_read_test();
              //clear_status_screen ();
              break;

         case 9:
              etc_decode_phase_write_test();
              //clear_status_screen ();
              break;

         case 10:
              etc_decode_phase_read_test();
              //clear_status_screen ();
              break;              

         case 11 :
              //ddr_settings_menu_memtest();
              break;

         case 12 :
              //memtest();
              break;
         case 13:
            etc_system_walking_one();
              break;
         case 14:
            etc_system_walking_zero();
              break;
         case 15:
            etc_system_address();
              break;
         default:
            printf ("\nInvalid input.  Try again.");
            break;

      }  // end switch (input)
   }	// end while (!done)
}  // end function


#include <asm/viper.h>
#define writel(b,addr) (*(volatile unsigned int *) (addr) = (b))
#define readl(addr) (*(volatile unsigned int *) (addr))

// ****************************************************************************************
// *                              7400 DDR SSO Test                                       *
// * Does a 1/0 sso write/read test to the 7400 Primary DDR using DMA.                    *
// * Inputs:   none                                                                       *
// * Outputs:  none                                                                       *
// *                                                                                      *
// ****************************************************************************************
#if 0
void dma_init(void){
	unsigned int temp;

	//Enable DMA Clock for memory test;
	temp = readl(MMREG_BASE + CG1_CLK_STOP0);
	writel(temp &(~DMACLK_STOP_MASK), MMREG_BASE + CG1_CLK_STOP0);

	temp = readl(MMREG_BASE + CG1_BLK_CLK_STOP0);
	writel(temp &(~DMA_MCLK_STOP_MASK),MMREG_BASE + CG1_BLK_CLK_STOP0 );

	temp = readl(MMREG_BASE + CG1_BLK_CLK_STOP1);
	writel(temp &(~DMA_DMACLK_STOP_MASK),MMREG_BASE + CG1_BLK_CLK_STOP1 );

	temp = readl(MMREG_BASE);
	temp |= DMA_RESET_MASK;
	writel(temp,MMREG_BASE);
	udelay(10);
	temp &= ~(DMA_RESET_MASK);
	writel(temp,MMREG_BASE);
}
#endif

void dma_write(unsigned int src, unsigned int dst, unsigned int length){
    unsigned int reg=0;
    writel(src,MMREG_BASE+DMA_DIRECT_LSRC_B);
    writel(dst,MMREG_BASE+DMA_DIRECT_LDST_B);
    reg=length;
    reg|=((1<<DMA_DIRECT_DMACMD_B_SRCSPACE_SHIFT)|(1<<DMA_DIRECT_DMACMD_B_DSTSPACE_SHIFT));
    writel(reg,MMREG_BASE+DMA_DIRECT_DMACMD_B);

//    printf("src:%x dst:%x length:%x reg:%x\n",src,dst,length,reg);
    while(DIRECT_B_MASK &readl(MMREG_BASE+DMA_STATUS) ){
  //  printf("dma:%x\n",readl(MMREG_BASE+DMA_STATUS));
    };
//    printf("src:%x dst:%x length:%x\n",src,dst,length);
    inv_dcache_range(dst,length); 

}

int dma_write_long(unsigned int src, unsigned int dst, unsigned int length){
     int _src=src;
     int _dst=dst;
     unsigned int len=64*1024;
     
    if(length %len )
        return -1;
     
    do {
            dma_write(_src,_dst,len);
            _src+=len;
            _dst+=len;
    }while(_src<dst);
    return 0;
}
void etc_system_sso_test(void)
{
  unsigned int done = 0;
  unsigned long ddr_source_addr = sso_test_base;
  unsigned long ddr_destination_addr = sso_test_base+SSO_BUFF;
  unsigned long i;
  unsigned char toggle = 0;
  unsigned char counter = 0;
  unsigned int j=0;
  unsigned int k=0;
   msso_printf("\netc_system_sso_test\n\0");
  if(!uui_msso_get_status()){
       printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x800000-1);
  }else{
        memset(line,0,1024);
        sprintf(line,"testing address:0x%x - 0x%x\n\0",ddr_source_addr,ddr_source_addr+0x800000-1);
        uui_msso_printf(line);
   }
      msso_printf("0xffffffff,0xffffffff,0x00000000,0x00000000\n\0");
      msso_printf("0x55555555,0x55555555,0xaaaaaaaa,0xaaaaaaaa\n\0");
      msso_printf("0xcccccccc,0xcccccccc,0x33333333,0x33333333\n\0");
      msso_printf("0x0f0f0f0f,0x0f0f0f0f,0xf0f0f0f0,0xf0f0f0f0\n\0");
      msso_printf("0x00000000,0x00000000,0xffffffff,0xffffffff\n\0");
      msso_printf("0xaaaaaaaa,0xaaaaaaaa,0x55555555,0x55555555\n\0");
      msso_printf("0x33333333,0x33333333,0xcccccccc,0xcccccccc\n\0");
      msso_printf("0xf0f0f0f0,0xf0f0f0f0,0x0f0f0f0f,0x0f0f0f0f\n\0");
 for ( i=0;i<0x100000 ;i+=16 )  //generate a SSO pattern in MEM0
   {
     *(unsigned long*)(ddr_source_addr+i)      = 0xffffffff;
     *(unsigned long*)(ddr_source_addr+(i+4))  = 0xffffffff;
     *(unsigned long*)(ddr_source_addr+(i+8))  = 0x00000000;
     *(unsigned long*)(ddr_source_addr+(i+12)) = 0x00000000;
   }
  for ( i=0x100000;i<0x200000 ;i+=16 )  //generate a SSO pattern in MEM0
   {
     *(unsigned long*)(ddr_source_addr+i)      = 0x55555555;
     *(unsigned long*)(ddr_source_addr+(i+4))  = 0x55555555;
     *(unsigned long*)(ddr_source_addr+(i+8))  = 0xaaaaaaaa;
     *(unsigned long*)(ddr_source_addr+(i+12)) = 0xaaaaaaaa;
   }
  for ( i=0x200000;i<0x300000 ;i+=16 )  //generate a SSO pattern in MEM0
   {
     *(unsigned long*)(ddr_source_addr+i)      = 0xcccccccc;
     *(unsigned long*)(ddr_source_addr+(i+4))  = 0xcccccccc;
     *(unsigned long*)(ddr_source_addr+(i+8))  = 0x33333333;
     *(unsigned long*)(ddr_source_addr+(i+12)) = 0x33333333;
   }
  for ( i=0x300000;i<0x400000 ;i+=16 )  //generate a SSO pattern in MEM0
   {
     *(unsigned long*)(ddr_source_addr+i)      = 0x0f0f0f0f;
     *(unsigned long*)(ddr_source_addr+(i+4))  = 0x0f0f0f0f;
     *(unsigned long*)(ddr_source_addr+(i+8))  = 0xf0f0f0f0;
     *(unsigned long*)(ddr_source_addr+(i+12)) = 0xf0f0f0f0;
   }

  for ( i=0x400000;i<0x500000 ;i+=16 )  //generate a SSO pattern in MEM0
   {
     *(unsigned long*)(ddr_source_addr+i)      = 0x00000000;
     *(unsigned long*)(ddr_source_addr+(i+4))  = 0x00000000;
     *(unsigned long*)(ddr_source_addr+(i+8))  = 0xffffffff;
     *(unsigned long*)(ddr_source_addr+(i+12)) = 0xffffffff;
   }
  for ( i=0x500000;i<0x600000 ;i+=16 )  //generate a SSO pattern in MEM0
   {
     *(unsigned long*)(ddr_source_addr+i)      = 0xaaaaaaaa;
     *(unsigned long*)(ddr_source_addr+(i+4))  = 0xaaaaaaaa;
     *(unsigned long*)(ddr_source_addr+(i+8))  = 0x55555555;
     *(unsigned long*)(ddr_source_addr+(i+12)) = 0x55555555;
   }         

  for ( i=0x600000;i<0x700000 ;i+=16 )  //generate a SSO pattern in MEM0
   {
     *(unsigned long*)(ddr_source_addr+i)      = 0x33333333;
     *(unsigned long*)(ddr_source_addr+(i+4))  = 0x33333333;
     *(unsigned long*)(ddr_source_addr+(i+8))  = 0xcccccccc;
     *(unsigned long*)(ddr_source_addr+(i+12)) = 0xcccccccc;
   }

  for ( i=0x700000;i<0x800000 ;i+=16 )  //generate a SSO pattern in MEM0
   {
     *(unsigned long*)(ddr_source_addr+i)      = 0xf0f0f0f0;
     *(unsigned long*)(ddr_source_addr+(i+4))  = 0xf0f0f0f0;
     *(unsigned long*)(ddr_source_addr+(i+8))  = 0x0f0f0f0f;
     *(unsigned long*)(ddr_source_addr+(i+12)) = 0x0f0f0f0f;
   }

    flush_dcache_range(ddr_source_addr,ddr_source_addr+0x800000);
  do{
  do {
    if(ddr_source_addr>sso_test_base){
        dma_write_long(ddr_source_addr-0x800000,ddr_source_addr,0x800000);
        if(!uui_msso_get_status()){
        printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x800000-1);
        }else{
            memset(line,0,1024);
            sprintf(line,"testing address:0x%x - 0x%x\n\0",ddr_source_addr,ddr_source_addr+0x800000-1);
            uui_msso_printf(line);
        }
    }

 for ( i=0;i<0x100000 ;i+=16 )  //generate a SSO pattern in MEM0
   {
     if (*(unsigned long*)(ddr_source_addr+i)      != 0xffffffff) goto etc_system_sso_test_error;
     if (*(unsigned long*)(ddr_source_addr+(i+4))  != 0xffffffff)  goto etc_system_sso_test_error;
     if (*(unsigned long*)(ddr_source_addr+(i+8))  != 0x00000000) goto etc_system_sso_test_error ;
     if (*(unsigned long*)(ddr_source_addr+(i+12)) != 0x00000000) goto etc_system_sso_test_error;
   }

  for ( i=0x100000;i<0x200000 ;i+=16 )  //generate a SSO pattern in MEM0
   {
     if(*(unsigned long*)(ddr_source_addr+i)      != 0x55555555) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0x55555555) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+8))  != 0xaaaaaaaa) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+12)) != 0xaaaaaaaa) goto etc_system_sso_test_error;
   }
  for ( i=0x200000;i<0x300000 ;i+=16 )  //generate a SSO pattern in MEM0
   {
     if(*(unsigned long*)(ddr_source_addr+i)      != 0xcccccccc) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0xcccccccc) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+8))  != 0x33333333) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+12)) != 0x33333333) goto etc_system_sso_test_error;
   }
  for ( i=0x300000;i<0x400000 ;i+=16 )  //generate a SSO pattern in MEM0
   {
     if(*(unsigned long*)(ddr_source_addr+i)      != 0x0f0f0f0f) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0x0f0f0f0f) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+8))  != 0xf0f0f0f0) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+12)) != 0xf0f0f0f0) goto etc_system_sso_test_error;
   }

  for ( i=0x400000;i<0x500000 ;i+=16 )  //generate a SSO pattern in MEM0
   {
     if(*(unsigned long*)(ddr_source_addr+i)      != 0x00000000) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0x00000000) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+8))  != 0xffffffff) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+12)) != 0xffffffff) goto etc_system_sso_test_error;
   }
  for ( i=0x500000;i<0x600000 ;i+=16 )  //generate a SSO pattern in MEM0
   {
     if(*(unsigned long*)(ddr_source_addr+i)      != 0xaaaaaaaa) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0xaaaaaaaa) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+8))  != 0x55555555) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+12)) != 0x55555555) goto etc_system_sso_test_error;
   }         

  for ( i=0x600000;i<0x700000 ;i+=16 )  //generate a SSO pattern in MEM0
   {
     if(*(unsigned long*)(ddr_source_addr+i)      != 0x33333333) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0x33333333) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+8))  != 0xcccccccc) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+12)) != 0xcccccccc) goto etc_system_sso_test_error;
   }

  for ( i=0x700000;i<0x800000 ;i+=16 )  //generate a SSO pattern in MEM0
   {
     if(*(unsigned long*)(ddr_source_addr+i)      != 0xf0f0f0f0) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0xf0f0f0f0) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+8))  != 0x0f0f0f0f) goto etc_system_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+12)) != 0x0f0f0f0f) goto etc_system_sso_test_error;
   }

    ddr_source_addr+=0x800000;

}while(ddr_source_addr + 0x800000< sso_test_end);
    ddr_source_addr = sso_test_base;
}while(j++<num_trail);
    msso_printf("passed!\n\0");
    return ;
etc_system_sso_test_error:
    msso_printf_error(ddr_source_addr,i);
} // end function



// ****************************************************************************************
// *                      7400 DDR One bit static SSO write Test                          *
// * Does a static bit write test to the 7400 Primary DDR.                                *
// * Inputs:   none                                                                       *
// * Outputs:  none                                                                       *
// *                                                                                      *
// ****************************************************************************************
void etc_system_static_write_test (void)
{
  char str[20];
  unsigned long sso_high_1s = 0xFFFFFFFF;
  unsigned long sso_low_1s = 0xFFFFFFFF;
  unsigned long sso_high_0s = 0x00000000;
  unsigned long sso_low_0s = 0x00000000;
  unsigned lower_mask = 0x00000000;
  unsigned upper_mask = 0x00000000;
  unsigned int select_bit;
  unsigned int high_or_low;
  unsigned int done = 0;
  unsigned long ddr_source_addr = sso_test_base;
  unsigned long ddr_destination_addr = sso_test_base+SSO_BUFF;
  unsigned long i;
  unsigned char toggle = 0;
  unsigned char counter = 0;
  unsigned int j=0;
  int len;
  select_bit=__select_bit;

  //check to see if bit number is between 0 and 31 
  if (select_bit<=31)
  {
    high_or_low=__high_or_low;

    //set masks
    if (select_bit <= 31)
     {
       lower_mask = 0x00000001;
       lower_mask = lower_mask << select_bit;
     }

    //check for valid selection of high or low, then mask bits
    if (high_or_low == 0)
     {
       sso_high_1s = sso_high_1s & (~upper_mask);
       sso_low_1s = sso_low_1s & (~lower_mask);
     }
    else if (high_or_low == 1)
     {
       sso_high_0s = sso_high_0s | upper_mask;
       sso_low_0s = sso_low_0s | lower_mask;
     }
    else
     {
       printf("\n Invalid Selection");
       return;
     }

  if(!uui_msso_get_status()){
    printf("\n etc_system_static_write_test\n");
    printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x200000-1);
    printf("0x%x 0x%x 0x%x 0x%x\n",sso_high_0s,sso_low_0s,sso_high_1s,sso_low_1s);
    printf("0x%x 0x%x 0x%x 0x%x\n",sso_high_1s,sso_low_1s,sso_high_0s,sso_low_0s);
}else{
   uui_msso_printf("\n etc_system_static_write_test\n\0");
    memset(line,0,1024);
    sprintf(line,"testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x200000-1);
    uui_msso_printf(line);
    sprintf(line,"0x%x 0x%x 0x%x 0x%x\n",sso_high_0s,sso_low_0s,sso_high_1s,sso_low_1s);
    uui_msso_printf(line);
    sprintf(line,"0x%x 0x%x 0x%x 0x%x\n",sso_high_1s,sso_low_1s,sso_high_0s,sso_low_0s);
    uui_msso_printf(line);
}
  for ( i=0;i<0x100000 ;i+=16 )  //generate a pattern in MEM0
     {
       *(unsigned long*)(ddr_source_addr+i)      = sso_high_0s;
       *(unsigned long*)(ddr_source_addr+(i+4))  = sso_low_0s;
       *(unsigned long*)(ddr_source_addr+(i+8))  = sso_high_1s;
       *(unsigned long*)(ddr_source_addr+(i+12)) = sso_low_1s;
     }
    for ( i=0x100000;i<0x200000 ;i+=16 )  //generate a pattern in MEM0
     {
       *(unsigned long*)(ddr_source_addr+i)      = sso_high_1s;
       *(unsigned long*)(ddr_source_addr+(i+4))  = sso_low_1s;
       *(unsigned long*)(ddr_source_addr+(i+8))  = sso_high_0s;
       *(unsigned long*)(ddr_source_addr+(i+12)) = sso_low_0s;
     }

    for ( i=0;i<0x100000 ;i+=16 )  //generate a pattern in MEM0
     {
       if(*(unsigned long*)(ddr_source_addr+i)      != sso_high_0s);
       if(*(unsigned long*)(ddr_source_addr+(i+4))  != sso_low_0s);
       if(*(unsigned long*)(ddr_source_addr+(i+8))  != sso_high_1s);
       if(*(unsigned long*)(ddr_source_addr+(i+12)) != sso_low_1s);
     }
    for ( i=0x100000;i<0x200000 ;i+=16 )  //generate a pattern in MEM0
     {
       if(*(unsigned long*)(ddr_source_addr+i)      != sso_high_1s);
       if(*(unsigned long*)(ddr_source_addr+(i+4))  != sso_low_1s);
       if(*(unsigned long*)(ddr_source_addr+(i+8))  != sso_high_0s);
       if(*(unsigned long*)(ddr_source_addr+(i+12)) != sso_low_0s);
     }
    flush_dcache_range(ddr_source_addr,ddr_source_addr+0x200000);
    do{ 
    do{
      if(ddr_source_addr>sso_test_base){
        dma_write_long(ddr_source_addr-0x200000,ddr_source_addr,0x200000);
        if(!uui_msso_get_status()){
            printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x200000-1);
        }
        else{
            memset(line,0,1024);
            sprintf(line,"testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x200000-1);
            uui_msso_printf(line);
             
        }
        }
    ddr_source_addr+=0x200000;
    }while(ddr_source_addr+0x200000<sso_test_end);
    ddr_source_addr=sso_test_base;
    }while(j++<num_trail);
   }
  else
   msso_printf("Invalid Selection\n\0"); //bit was not between 0 and 31
    msso_printf("pass\n\0");
return;
etc_system_static_write_test_error:
    msso_printf_error(ddr_source_addr,i);
} // end function




// ****************************************************************************************
// *                    7400 DDR One bit out of phase SSO write Test                      *
// * Does a out of phase bit write test to the 7400 Primary DDR.                          *
// * Inputs:   none                                                                       *
// * Outputs:  none                                                                       *
// *                                                                                      *
// ****************************************************************************************
void etc_system_phase_write_test (void)
{
  char str[20];
  unsigned long sso_high_1s = 0xFFFFFFFF;
  unsigned long sso_low_1s = 0xFFFFFFFF;
  unsigned long sso_high_0s = 0x00000000;
  unsigned long sso_low_0s = 0x00000000;
  unsigned lower_mask = 0x00000000;
  unsigned upper_mask = 0x00000000;
  unsigned int select_bit;
  unsigned int done = 0;
  unsigned long ddr_source_addr = sso_test_base;
  unsigned long ddr_destination_addr = sso_test_base+SSO_BUFF;
  unsigned long i;
  unsigned char toggle = 0;
  unsigned char counter = 0;
  int len;
  unsigned int j;
  select_bit=__select_bit;
  //check to see if bit number is between 0 and 31
  if (select_bit<=31)
   {
     //set masks
     if (select_bit <= 31)
      {
        lower_mask = 0x00000001;
        lower_mask = lower_mask << select_bit;
      }
	
    sso_high_1s = sso_high_1s & (~upper_mask);
    sso_low_1s = sso_low_1s & (~lower_mask);
    sso_high_0s = sso_high_0s | upper_mask;
    sso_low_0s = sso_low_0s | lower_mask;

    msso_printf("\netc_system_phase_write_test\n\0");
    if(!uui_msso_get_status()){
    printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x400000-1);
    printf("0x%x 0x%x 0x%x 0x%x\n",sso_high_0s,sso_low_0s,sso_high_1s,sso_low_1s);
    printf("0x%x 0x%x 0x%x 0x%x\n",sso_high_1s,sso_low_1s,sso_high_0s,sso_low_0s);
    printf("0x%x 0x%x 0x%x 0x%x\n",0xffffffff,0xffffffff,0x0,0x0);
    printf("0x%x 0x%x 0x%x 0x%x\n",0x0,0x0,0xffffffff,0xffffffff);
}else{
    memset(line,0,1024);
    sprintf(line,"testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x400000-1);
    uui_msso_printf(line);
    memset(line,0,1024);
    sprintf(line,"0x%x 0x%x 0x%x 0x%x\n",sso_high_0s,sso_low_0s,sso_high_1s,sso_low_1s);
    uui_msso_printf(line);
    memset(line,0,1024);
    sprintf(line,"0x%x 0x%x 0x%x 0x%x\n",sso_high_1s,sso_low_1s,sso_high_0s,sso_low_0s);
    uui_msso_printf(line);
    memset(line,0,1024);
    sprintf(line,"0x%x 0x%x 0x%x 0x%x\n",0xffffffff,0xffffffff,0x0,0x0);
    uui_msso_printf(line);
    memset(line,0,1024);
    sprintf(line,"0x%x 0x%x 0x%x 0x%x\n",0x0,0x0,0xffffffff,0xffffffff);
    uui_msso_printf(line);
}
 
   for ( i=0;i<0x100000 ;i+=16 )  //generate a pattern in MEM0
      {
        *(unsigned long*)(ddr_source_addr+i)      = sso_high_0s;
        *(unsigned long*)(ddr_source_addr+(i+4))  = sso_low_0s;
        *(unsigned long*)(ddr_source_addr+(i+8))  = sso_high_1s;
        *(unsigned long*)(ddr_source_addr+(i+12)) = sso_low_1s;
      }
     for ( i=0x100000;i<0x200000 ;i+=16 )  //generate a pattern in MEM0
      {
        *(unsigned long*)(ddr_source_addr+i)      = sso_high_1s;
        *(unsigned long*)(ddr_source_addr+(i+4))  = sso_low_1s;
        *(unsigned long*)(ddr_source_addr+(i+8))  = sso_high_0s;
        *(unsigned long*)(ddr_source_addr+(i+12)) = sso_low_0s;
      }
     for ( i=0x200000;i<0x300000 ;i+=16 )  //generate a pattern in MEM0
      {
        *(unsigned long*)(ddr_source_addr+i)      = 0xffffffff;
        *(unsigned long*)(ddr_source_addr+(i+4))  = 0xffffffff;
        *(unsigned long*)(ddr_source_addr+(i+8))  = 0x00000000;
        *(unsigned long*)(ddr_source_addr+(i+12)) = 0x00000000;
      }
     for ( i=0x300000;i<0x400000 ;i+=16 )  //generate a pattern in MEM0
      {
        *(unsigned long*)(ddr_source_addr+i)      = 0x00000000;
        *(unsigned long*)(ddr_source_addr+(i+4))  = 0x00000000;
        *(unsigned long*)(ddr_source_addr+(i+8))  = 0xffffffff;
        *(unsigned long*)(ddr_source_addr+(i+12)) = 0xffffffff;
      }
  
    flush_dcache_range(ddr_source_addr,ddr_source_addr+0x400000);
    do{
    do {
    if(ddr_source_addr>sso_test_base){
        dma_write_long(ddr_source_addr-0x400000,ddr_source_addr,0x400000);
        if(!uui_msso_get_status()){
            printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x400000-1);
        }else{
            memset(line,0,1024);
            sprintf(line,"testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x400000-1);
            uui_msso_printf(line);
        }
    }
     ddr_source_addr+=0x400000;
    }while(ddr_source_addr+0x400000<sso_test_end);
    ddr_source_addr=sso_test_base;
    }while(j++<num_trail);
    }
  else
   msso_printf("Invalid Selection\n\0"); //bit was not between 0 and 31
   msso_printf("pass\n\0");
return;
etc_system_phase_write_test_error:
    msso_printf_error(ddr_source_addr,i);
} // end function
		



// ****************************************************************************************
// *                    7400 DDR One bit Static SSO read Test                             *
// * Does a static bit read test to the 7400 Primary DDR.                                 *
// * Inputs:   none                                                                       *
// * Outputs:  none                                                                       *
// *                                                                                      *
// ****************************************************************************************
void etc_system_static_read_test (void)
{
  char str[20];
  unsigned long sso_high_1s = 0xFFFFFFFF;
  unsigned long sso_low_1s = 0xFFFFFFFF;
  unsigned long sso_high_0s = 0x00000000;
  unsigned long sso_low_0s = 0x00000000;
  unsigned lower_mask = 0x00000000;
  unsigned upper_mask = 0x00000000;
  unsigned int select_bit;
  unsigned int high_or_low;
  unsigned int done = 0;
  unsigned long ddr_source_addr = sso_test_base;
  unsigned long ddr_destination_addr = sso_test_base+SSO_BUFF;
  unsigned long i;
  unsigned char toggle = 0;
  unsigned char counter = 0;
  int len;
  unsigned int j;

   select_bit=__select_bit;
  //check to see if bit number is between 0 and 31
  if (select_bit<=31)
   {
     high_or_low=__high_or_low;

     //set masks
     if (select_bit <= 31)
      {
        lower_mask = 0x00000001;
        lower_mask = lower_mask << select_bit;
      }

     //check for valid selection of high or low, then mask bits
     if (high_or_low == 0)
      {
        sso_high_1s = sso_high_1s & (~upper_mask);
        sso_low_1s = sso_low_1s & (~lower_mask);
      }
     else if (high_or_low == 1)
      {
        sso_high_0s = sso_high_0s | upper_mask;
        sso_low_0s = sso_low_0s | lower_mask;
      }
     else
      {
        printf("\n Invalid Selection");
        return;
      }

     msso_printf("\n etc_system_static_read_test\n\0");
  if(!uui_msso_get_status()){
    printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x200000-1);
    printf("0x%x 0x%x 0x%x 0x%x\n",sso_high_0s,sso_low_0s,sso_high_1s,sso_low_1s);
    printf("0x%x 0x%x 0x%x 0x%x\n",sso_high_1s,sso_low_1s,sso_high_0s,sso_low_0s);
}else{
    memset(line,0,1024);
    sprintf(line,"testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x200000-1);
    uui_msso_printf(line);
    memset(line,0,1024);
    sprintf(line,"0x%x 0x%x 0x%x 0x%x\n",sso_high_0s,sso_low_0s,sso_high_1s,sso_low_1s);
    uui_msso_printf(line);
    memset(line,0,1024);
    sprintf(line,"0x%x 0x%x 0x%x 0x%x\n",sso_high_1s,sso_low_1s,sso_high_0s,sso_low_0s);
    uui_msso_printf(line);
}
 
     for ( i=0;i<0x100000 ;i+=16 )  //generate a pattern in MEM0
      {
        *(unsigned long*)(ddr_source_addr+i)      = sso_high_0s;
        *(unsigned long*)(ddr_source_addr+(i+4))  = sso_low_0s;
        *(unsigned long*)(ddr_source_addr+(i+8))  = sso_high_1s;
        *(unsigned long*)(ddr_source_addr+(i+12)) = sso_low_1s;
      }
     for ( i=0x100000;i<0x200000 ;i+=16 )  //generate a pattern in MEM0
      {
        *(unsigned long*)(ddr_source_addr+i)      = sso_high_1s;
        *(unsigned long*)(ddr_source_addr+(i+4))  = sso_low_1s;
        *(unsigned long*)(ddr_source_addr+(i+8))  = sso_high_0s;
        *(unsigned long*)(ddr_source_addr+(i+12)) = sso_low_0s;
      }

    flush_dcache_range(ddr_source_addr,ddr_source_addr+0x200000);
    do{ 
    do{
    if(ddr_source_addr>sso_test_base){
        dma_write_long(ddr_source_addr-0x200000,ddr_source_addr,0x200000);
      if(!uui_msso_get_status()){
            printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x200000-1);
        }else{
            memset(line,0,1024);
            sprintf(line,"testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x200000-1);
            uui_msso_printf(line);
        }
    }
     for ( i=0;i<0x100000 ;i+=16 )  //generate a pattern in MEM0
      {
        if(*(unsigned long*)(ddr_source_addr+i)      != sso_high_0s) goto etc_system_static_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+4))  != sso_low_0s)goto etc_system_static_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+8))  != sso_high_1s)goto etc_system_static_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+12)) != sso_low_1s)goto etc_system_static_read_test_error;
      }
     for ( i=0x100000;i<0x200000 ;i+=16 )  //generate a pattern in MEM0
      {
        if(*(unsigned long*)(ddr_source_addr+i)      != sso_high_1s)goto etc_system_static_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+4))  != sso_low_1s)goto etc_system_static_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+8))  != sso_high_0s)goto etc_system_static_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+12)) != sso_low_0s)goto etc_system_static_read_test_error;
      }   
     ddr_source_addr+=0x200000;
    }while(ddr_source_addr+0x200000<sso_test_end);
    ddr_source_addr=sso_test_base;
    }while(j++<num_trail);
   }
  else
   msso_printf("Invalid Selection\n\0"); //bit was not between 0 and 31
    msso_printf("passed!\n");
    return ;
etc_system_static_read_test_error:
    msso_printf_error(ddr_source_addr,i);
} // end function



// ****************************************************************************************
// *                    7400 DDR One bit out of phase SSO read Test                       *
// * Does a out of phase bit read test to the 7400 Primary DDR.                           *
// * Inputs:   none                                                                       *
// * Outputs:  none                                                                       *
// *                                                                                      *
// ****************************************************************************************
void etc_system_phase_read_test (void)
{
  char str[20];
  unsigned long sso_high_1s = 0xFFFFFFFF;
  unsigned long sso_low_1s = 0xFFFFFFFF;
  unsigned long sso_high_0s = 0x00000000;
  unsigned long sso_low_0s = 0x00000000;
  unsigned lower_mask = 0x00000000;
  unsigned upper_mask = 0x00000000;
  unsigned int select_bit;
  unsigned int done = 0;
  unsigned long ddr_source_addr = sso_test_base;
  unsigned long ddr_destination_addr = sso_test_base+SSO_BUFF;
  unsigned long i;
  unsigned char toggle = 0;
  unsigned char counter = 0;
  int len;
  unsigned int j;

  select_bit=__select_bit;

  //check to see if bit number is between 0 and 31
  if (select_bit<=31)
   {
     //set masks
     if (select_bit <= 31)
      {
        lower_mask = 0x00000001;
        lower_mask = lower_mask << select_bit;
      }
	
     sso_high_1s = sso_high_1s & (~upper_mask);
     sso_low_1s = sso_low_1s & (~lower_mask);
     sso_high_0s = sso_high_0s | upper_mask;
     sso_low_0s = sso_low_0s | lower_mask;

     msso_printf("\n etc_system_phase_read_test\n\0");
 if(!uui_msso_get_status()){
    printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x400000-1);
    printf("0x%x 0x%x 0x%x 0x%x\n",sso_high_0s,sso_low_0s,sso_high_1s,sso_low_1s);
    printf("0x%x 0x%x 0x%x 0x%x\n",sso_high_1s,sso_low_1s,sso_high_0s,sso_low_0s);
    printf("0x%x 0x%x 0x%x 0x%x\n",0xffffffff,0xffffffff,0x0,0x0);
    printf("0x%x 0x%x 0x%x 0x%x\n",0x0,0x0,0xffffffff,0xffffffff);
}else{
    memset(line,0,1024);
    sprintf(line,"testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x400000-1);
    uui_msso_printf(line);
    memset(line,0,1024);
    sprintf(line,"0x%x 0x%x 0x%x 0x%x\n",sso_high_0s,sso_low_0s,sso_high_1s,sso_low_1s);
    uui_msso_printf(line);
    memset(line,0,1024);
    sprintf(line,"0x%x 0x%x 0x%x 0x%x\n",sso_high_1s,sso_low_1s,sso_high_0s,sso_low_0s);
    uui_msso_printf(line);
    memset(line,0,1024);
    sprintf(line,"0x%x 0x%x 0x%x 0x%x\n",0xffffffff,0xffffffff,0x0,0x0);
    uui_msso_printf(line);
    memset(line,0,1024);
    sprintf(line,"0x%x 0x%x 0x%x 0x%x\n",0x0,0x0,0xffffffff,0xffffffff);
    uui_msso_printf(line);
}
     for ( i=0;i<0x100000 ;i+=16 )  //generate a pattern in MEM0
      {
        *(unsigned long*)(ddr_source_addr+i)      = sso_high_0s;
        *(unsigned long*)(ddr_source_addr+(i+4))  = sso_low_0s;
        *(unsigned long*)(ddr_source_addr+(i+8))  = sso_high_1s;
        *(unsigned long*)(ddr_source_addr+(i+12)) = sso_low_1s;
      }
     for ( i=0x100000;i<0x200000 ;i+=16 )  //generate a pattern in MEM0
      {
        *(unsigned long*)(ddr_source_addr+i)      = sso_high_1s;
        *(unsigned long*)(ddr_source_addr+(i+4))  = sso_low_1s;
        *(unsigned long*)(ddr_source_addr+(i+8))  = sso_high_0s;
        *(unsigned long*)(ddr_source_addr+(i+12)) = sso_low_0s;
      }
     for ( i=0x200000;i<0x300000 ;i+=16 )  //generate a pattern in MEM0
      {
        *(unsigned long*)(ddr_source_addr+i)      = 0xffffffff;
        *(unsigned long*)(ddr_source_addr+(i+4))  = 0xffffffff;
        *(unsigned long*)(ddr_source_addr+(i+8))  = 0x00000000;
        *(unsigned long*)(ddr_source_addr+(i+12)) = 0x00000000;
      }
     for ( i=0x300000;i<0x400000 ;i+=16 )  //generate a pattern in MEM0
      {
        *(unsigned long*)(ddr_source_addr+i)      = 0x00000000;
        *(unsigned long*)(ddr_source_addr+(i+4))  = 0x00000000;
        *(unsigned long*)(ddr_source_addr+(i+8))  = 0xffffffff;
        *(unsigned long*)(ddr_source_addr+(i+12)) = 0xffffffff;
      }      

    flush_dcache_range(ddr_source_addr,ddr_source_addr+0x400000);
     do{
     do{
    if(ddr_source_addr>sso_test_base){
        dma_write_long(ddr_source_addr-0x400000,ddr_source_addr,0x400000);
         if(!uui_msso_get_status()){
        printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x400000-1);
        }else{
            memset(line,0,1024);
            sprintf(line,"testing address:0x%x - 0x%x\n\0",ddr_source_addr,ddr_source_addr+0x400000-1);
            uui_msso_printf(line);
        }
    }
    for ( i=0;i<0x100000 ;i+=16 )  //generate a pattern in MEM0
      {
        if(*(unsigned long*)(ddr_source_addr+i)      != sso_high_0s) goto etc_system_phase_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+4))  != sso_low_0s) goto etc_system_phase_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+8))  != sso_high_1s) goto etc_system_phase_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+12)) != sso_low_1s) goto etc_system_phase_read_test_error;
      }
     for ( i=0x100000;i<0x200000 ;i+=16 )  //generate a pattern in MEM0
      {
        if(*(unsigned long*)(ddr_source_addr+i)      != sso_high_1s) goto etc_system_phase_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+4))  != sso_low_1s) goto etc_system_phase_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+8))  != sso_high_0s) goto etc_system_phase_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+12)) != sso_low_0s) goto etc_system_phase_read_test_error;
      }
     for ( i=0x200000;i<0x300000 ;i+=16 )  //generate a pattern in MEM0
      {
        if(*(unsigned long*)(ddr_source_addr+i)      != 0xffffffff) goto etc_system_phase_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0xffffffff) goto etc_system_phase_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+8))  != 0x00000000) goto etc_system_phase_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+12)) != 0x00000000) goto etc_system_phase_read_test_error;
      }
     for ( i=0x300000;i<0x400000 ;i+=16 )  //generate a pattern in MEM0
      {
        if(*(unsigned long*)(ddr_source_addr+i)      != 0x00000000) goto etc_system_phase_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0x00000000) goto etc_system_phase_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+8))  != 0xffffffff) goto etc_system_phase_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+12)) != 0xffffffff) goto etc_system_phase_read_test_error;
      } 
     ddr_source_addr+=0x400000;
    }while(ddr_source_addr+0x400000<sso_test_end);      
    ddr_source_addr=sso_test_base;
    }while(j++<num_trail);
   }
  else
   msso_printf("Invalid Selection\n\0"); //bit was not between 0 and 31
    
   msso_printf("passed!\n");return;
etc_system_phase_read_test_error:
   msso_printf_error(ddr_source_addr,i);

} // end function



// ****************************************************************************************
// *                              7400 DDR SSO Test                                       *
// * Does a 1/0 sso write/read test to the 7400 Decode DDR using DMA.                     *
// * Inputs:   none                                                                       *
// * Outputs:  none                                                                       *
// *                                                                                      *
// ****************************************************************************************
void etc_decode_sso_test(void)
{
  unsigned int done = 0;
  unsigned long ddr_source_addr = sso_test_base;
  unsigned long ddr_destination_addr = sso_test_base+SSO_BUFF;
  uint8_t *memc1_destination_addr;// = sso_test_base2;
  uint8_t *memc2_destination_addr;// = sso_test_base3;
  unsigned long i;
  unsigned char toggle = 0;
  unsigned char counter = 0;
  unsigned int j=0;

  msso_printf("\netc_decode_sso_test\n\0");
 if(!uui_msso_get_status()){
 printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x800000-1);
}else{
  memset(line,0,1024);
  sprintf(line,"testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x800000-1);
  uui_msso_printf(line);
}

  msso_printf("0x0xffff0000,0x0000ffff\n");
  msso_printf("0x5555aaaa,0xaaaa5555\n");
  msso_printf("0xcccc3333,0x3333cccc\n");
  msso_printf("0x0f0f0f0f,0xf0f0f0f0\n");
  msso_printf("0x0000ffff,0xffff0000\n");
  msso_printf("0xaaaa5555,0x5555aaaa\n");
  msso_printf("0x3333cccc,0xcccc3333\n");
  msso_printf("0xf0f0f0f0,0x0f0f0f0f\n");

 for ( i=0;i<0x100000 ;i+=8 )  //generate a SSO pattern in MEM0
   {
     *(unsigned long*)(ddr_source_addr+i)      = 0xffff0000;
     *(unsigned long*)(ddr_source_addr+(i+4))  = 0x0000ffff;
   }
  for ( i=0x100000;i<0x200000 ;i+=8 )  //generate a SSO pattern in MEM0
   {
     *(unsigned long*)(ddr_source_addr+i)      = 0x5555aaaa;
     *(unsigned long*)(ddr_source_addr+(i+4))  = 0xaaaa5555;
   }
  for ( i=0x200000;i<0x300000 ;i+=8 )  //generate a SSO pattern in MEM0
   {
     *(unsigned long*)(ddr_source_addr+i)      = 0xcccc3333;
     *(unsigned long*)(ddr_source_addr+(i+4))  = 0x3333cccc;
   }
  for ( i=0x300000;i<0x400000 ;i+=8 )  //generate a SSO pattern in MEM0
   {
     *(unsigned long*)(ddr_source_addr+i)      = 0x0f0ff0f0;
     *(unsigned long*)(ddr_source_addr+(i+4))  = 0xf0f00f0f;
   }

  for ( i=0x400000;i<0x500000 ;i+=8 )  //generate a SSO pattern in MEM0
   {
     *(unsigned long*)(ddr_source_addr+i)      = 0x0000ffff;
     *(unsigned long*)(ddr_source_addr+(i+4))  = 0xffff0000;
   }
  for ( i=0x500000;i<0x600000 ;i+=8 )  //generate a SSO pattern in MEM0
   {
     *(unsigned long*)(ddr_source_addr+i)      = 0xaaaa5555;
     *(unsigned long*)(ddr_source_addr+(i+4))  = 0x5555aaaa;
   }

  for ( i=0x600000;i<0x700000 ;i+=8 )  //generate a SSO pattern in MEM0
   {
     *(unsigned long*)(ddr_source_addr+i)      = 0x3333cccc;
     *(unsigned long*)(ddr_source_addr+(i+4))  = 0xcccc3333;
   }

  for ( i=0x700000;i<0x800000 ;i+=8 )  //generate a SSO pattern in MEM0
   {
     *(unsigned long*)(ddr_source_addr+i)      = 0xf0f00f0f;
     *(unsigned long*)(ddr_source_addr+(i+4))  = 0x0f0ff0f0;
   }
    flush_dcache_range(ddr_source_addr,ddr_source_addr+0x800000);
  do{
  do{
     if(ddr_source_addr>sso_test_base){
        dma_write_long(ddr_source_addr-0x800000,ddr_source_addr,0x800000);
       if(!uui_msso_get_status()){
        printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x800000-1);
        }else{
            memset(line,0,1024);
            sprintf(line,"testing address:0x%x - 0x%x\n\0",ddr_source_addr,ddr_source_addr+0x800000-1);
            uui_msso_printf(line);
        }
    }

  for ( i=0;i<0x100000 ;i+=8 )  //generate a SSO pattern in MEM0
   {
     if(*(unsigned long*)(ddr_source_addr+i)      != 0xffff0000) goto etc_decode_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0x0000ffff) goto etc_decode_sso_test_error;
   }
  for ( i=0x100000;i<0x200000 ;i+=8 )  //generate a SSO pattern in MEM0
   {
     if(*(unsigned long*)(ddr_source_addr+i)      != 0x5555aaaa) goto etc_decode_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0xaaaa5555) goto etc_decode_sso_test_error;
   }
  for ( i=0x200000;i<0x300000 ;i+=8 )  //generate a SSO pattern in MEM0
   {
     if(*(unsigned long*)(ddr_source_addr+i)      != 0xcccc3333) goto etc_decode_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0x3333cccc) goto etc_decode_sso_test_error;
   }
  for ( i=0x300000;i<0x400000 ;i+=8 )  //generate a SSO pattern in MEM0
   {
     if(*(unsigned long*)(ddr_source_addr+i)      != 0x0f0ff0f0) goto etc_decode_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0xf0f00f0f) goto etc_decode_sso_test_error;
   }

  for ( i=0x400000;i<0x500000 ;i+=8 )  //generate a SSO pattern in MEM0
   {
     if(*(unsigned long*)(ddr_source_addr+i)      != 0x0000ffff) goto etc_decode_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0xffff0000) goto etc_decode_sso_test_error;
   }
  for ( i=0x500000;i<0x600000 ;i+=8 )  //generate a SSO pattern in MEM0
   {
     if(*(unsigned long*)(ddr_source_addr+i)      != 0xaaaa5555) goto etc_decode_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0x5555aaaa) goto etc_decode_sso_test_error;
   }

  for ( i=0x600000;i<0x700000 ;i+=8 )  //generate a SSO pattern in MEM0
   {
     if(*(unsigned long*)(ddr_source_addr+i)      != 0x3333cccc) goto etc_decode_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0xcccc3333) goto etc_decode_sso_test_error;
   }

  for ( i=0x700000;i<0x800000 ;i+=8 )  //generate a SSO pattern in MEM0
   {
     if(*(unsigned long*)(ddr_source_addr+i)      != 0xf0f00f0f) goto etc_decode_sso_test_error;
     if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0x0f0ff0f0) goto etc_decode_sso_test_error;
   }
 ddr_source_addr+=0x800000;
    }while(ddr_source_addr+0x800000<sso_test_end);
    ddr_source_addr=sso_test_base;
    }while(j++<num_trail);

    msso_printf("passed!\n\0");return;
etc_decode_sso_test_error:
    msso_printf_error(ddr_source_addr,i);
} // end function



// ****************************************************************************************
// *                      7400 DDR One bit static SSO write Test                          *
// * Does a static bit write test to the 7400 Decode DDR.                                 *
// * Inputs:   none                                                                       *
// * Outputs:  none                                                                       *
// *                                                                                      *
// ****************************************************************************************
void etc_decode_static_write_test (void)
{
  char str[20];
  unsigned long decode_sso_data = 0x0000FFFF;
  unsigned long decode_sso_data2 = 0xFFFF0000;
  unsigned decode_mask = 0x00010001;
  unsigned int select_bit;
  unsigned int high_or_low;
  unsigned int done = 0;
  unsigned long ddr_source_addr = sso_test_base;
  unsigned long ddr_destination_addr = sso_test_base+SSO_BUFF;
  uint8_t *memc1_destination_addr;// = sso_test_base2;
  uint8_t *memc2_destination_addr;// = sso_test_base3;
  unsigned long i;
  unsigned char toggle = 0;
  unsigned char counter = 0;
  int len;
  unsigned int j=0;

  select_bit=__select_bit;

  //check to see if bit number is between 0 and 15
  if (select_bit<=15)
   {
     high_or_low=__high_or_low;

     //set masks
     decode_mask = decode_mask << select_bit;

     //check for valid selection of high or low, then mask bits
     if (high_or_low == 0)
      {
        decode_sso_data = decode_sso_data & (~decode_mask);
        decode_sso_data2 = decode_sso_data2 & (~decode_mask);
      }
     else if (high_or_low == 1)
      {
        decode_sso_data = decode_sso_data | decode_mask;
        decode_sso_data2 = decode_sso_data2 | decode_mask;
      }
     else
      {
        printf("\n Invalid Selection");/*
        BMEM_Free( b_board.b7400.memc16[0], memc1_destination_addr);
        BMEM_Free( b_board.b7400.memc16[1], memc2_destination_addr);*/
        return;
      }

    msso_printf("\n etc_decode_static_write_test\n\0");
    if(!uui_msso_get_status()){
    printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x500000-1);
    printf("0x%x\n",decode_sso_data);
    printf("0x%x\n",decode_sso_data2);

}else{
  memset(line,0,1024);
  sprintf(line,"testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x500000-1);
  uui_msso_printf(line);
  memset(line,0,1024);
    sprintf(line,"0x%x\n",decode_sso_data);
  uui_msso_printf(line);
  memset(line,0,1024);
    sprintf(line,"0x%x\n",decode_sso_data2);
  uui_msso_printf(line);

}

   msso_printf("0xffff0000,0x0000ffff\n");
   msso_printf("0x0000ffff,0xffff0000\n");
 for ( i=0;i<0x100000 ;i+=4 )  //generate a pattern in MEM0
       *(unsigned long*)(ddr_source_addr+i) = decode_sso_data;
     for ( i=0x100000;i<0x200000 ;i+=4 )  //generate a pattern in MEM0
       *(unsigned long*)(ddr_source_addr+i) = decode_sso_data2;
     for ( i=0x300000;i<0x400000 ;i+=8 )  //generate a pattern in MEM0
      {
        *(unsigned long*)(ddr_source_addr+i)      = 0xffff0000;
        *(unsigned long*)(ddr_source_addr+(i+4))  = 0x0000ffff;
      }
     for ( i=0x400000;i<0x500000 ;i+=8 )  //generate a pattern in MEM0
      {
        *(unsigned long*)(ddr_source_addr+i)      = 0x0000ffff;
        *(unsigned long*)(ddr_source_addr+(i+4))  = 0xffff0000;
      }
    flush_dcache_range(ddr_source_addr,ddr_source_addr+0x500000);
    do{
    do{
        if(ddr_source_addr>sso_test_base){
            dma_write_long(ddr_source_addr-0x500000,ddr_source_addr,0x500000);
       if(!uui_msso_get_status()){
        printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x500000-1);
        }else{
            memset(line,0,1024);
            sprintf(line,"testing address:0x%x - 0x%x\n\0",ddr_source_addr,ddr_source_addr+0x500000-1);
            uui_msso_printf(line);
        }
        }


      for ( i=0;i<0x100000 ;i+=4 )  //generate a pattern in MEM0
        if(*(unsigned long*)(ddr_source_addr+i) != decode_sso_data) goto etc_decode_static_write_test_error;
     for ( i=0x100000;i<0x200000 ;i+=4 )  //generate a pattern in MEM0
        if(*(unsigned long*)(ddr_source_addr+i) != decode_sso_data2) goto etc_decode_static_write_test_error;

     for ( i=0x300000;i<0x400000 ;i+=8 )  //generate a pattern in MEM0
      {
        if(*(unsigned long*)(ddr_source_addr+i)      != 0xffff0000) goto etc_decode_static_write_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0x0000ffff) goto etc_decode_static_write_test_error;
      }
     for ( i=0x400000;i<0x500000 ;i+=8 )  //generate a pattern in MEM0
      {
        if(*(unsigned long*)(ddr_source_addr+i)      != 0x0000ffff) goto etc_decode_static_write_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0xffff0000) goto etc_decode_static_write_test_error;
      }
     ddr_source_addr+=0x500000;
    }while(ddr_source_addr+0x500000<sso_test_end);
    ddr_source_addr=sso_test_base;
    }while(j++<num_trail);
   }
  else
   msso_printf(" Invalid Selection\n\0"); //bit was not between 0 and 31
    msso_printf("passed!\n0");return; 
etc_decode_static_write_test_error:
     msso_printf_error(ddr_source_addr,i);
/*
  BMEM_Free( b_board.b7400.memc16[0], memc1_destination_addr);
  BMEM_Free( b_board.b7400.memc16[1], memc2_destination_addr);*/
} // end function




// ****************************************************************************************
// *                    7400 DDR One bit out of phase SSO write Test                      *
// * Does a out of phase bit write test to the 7400 Decode DDR.                           *
// * Inputs:   none                                                                       *
// * Outputs:  none                                                                       *
// *                                                                                      *
// ****************************************************************************************
void etc_decode_phase_write_test (void)
{
  char str[20];
  unsigned long decode_sso_data = 0x0000FFFF;
  unsigned long decode_sso_data2 = 0xFFFF0000;
  unsigned decode_mask = 0x00010001;
  unsigned int select_bit;
  unsigned int done = 0;
  unsigned long ddr_source_addr = sso_test_base;
  unsigned long ddr_destination_addr = sso_test_base+SSO_BUFF;
  uint8_t *memc1_destination_addr;// = sso_test_base2;
  uint8_t *memc2_destination_addr;// = sso_test_base3;
  unsigned long i;
  unsigned char toggle = 0;
  unsigned char counter = 0;
  int len;
  unsigned int j=0;

  select_bit=__select_bit;

  //check to see if bit number is between 0 and 15
  if (select_bit<=15)
   {
     //set masks
    decode_mask = decode_mask << select_bit;
    decode_sso_data = decode_sso_data & (~decode_mask);  //clear the correct bit in the FFFF portion of pattern
    decode_sso_data = decode_sso_data | (decode_mask & 0xffff0000);  //set the correct bit in the 0000 portion of pattern
    decode_sso_data2 = decode_sso_data2 & (~decode_mask);  //clear the correct bit in the FFFF portion of pattern
    decode_sso_data2 = decode_sso_data2 | (decode_mask & 0x0000ffff);  //set the correct bit in the 0000 portion of pattern

    msso_printf("\netc_decode_phase_write_test\n\0");
    if(!uui_msso_get_status()){

    printf("0x%x\n",decode_sso_data);
    printf("0x%x\n",decode_sso_data2);

}else{
  memset(line,0,1024);
  sprintf(line,"testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x200000-1);
  uui_msso_printf(line);

  memset(line,0,1024);
    sprintf(line,"0x%x\n",decode_sso_data);
  uui_msso_printf(line);
  memset(line,0,1024);
    sprintf(line,"0x%x\n",decode_sso_data2);
  uui_msso_printf(line);

}



     for ( i=0;i<0x100000 ;i+=4 )  //generate a pattern in MEM0
       *(unsigned long*)(ddr_source_addr+i) = decode_sso_data;
     for ( i=0x100000;i<0x200000 ;i+=4 )  //generate a pattern in MEM0
       *(unsigned long*)(ddr_source_addr+i) = decode_sso_data2;
    flush_dcache_range(ddr_source_addr,ddr_source_addr+0x200000);
    do{
    do{
    if(ddr_source_addr>sso_test_base){
        dma_write_long(ddr_source_addr-0x200000,ddr_source_addr,0x200000);
   if(!uui_msso_get_status()){
        printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x200000-1);
        }else{
            memset(line,0,1024);
            sprintf(line,"testing address:0x%x - 0x%x\n\0",ddr_source_addr,ddr_source_addr+0x200000-1);
            uui_msso_printf(line);
        }
    }

     for ( i=0;i<0x100000 ;i+=4 )  //generate a pattern in MEM0
       if(*(unsigned long*)(ddr_source_addr+i) != decode_sso_data) goto etc_decode_phase_write_test_error;
     for ( i=0x100000;i<0x200000 ;i+=4 )  //generate a pattern in MEM0
       if(*(unsigned long*)(ddr_source_addr+i) != decode_sso_data2) goto etc_decode_phase_write_test_error;
 ddr_source_addr+=0x200000;
    }while(ddr_source_addr+0x200000<sso_test_end);
    ddr_source_addr = sso_test_base;
}while(j++<num_trail);
    }
  else
   msso_printf(" Invalid Selection\n\0"); //bit was not between 0 and 31
/*
  BMEM_Free( b_board.b7400.memc16[0], memc1_destination_addr);
  BMEM_Free( b_board.b7400.memc16[1], memc2_destination_addr);*/
  msso_printf("passed!\n\0");return; 
etc_decode_phase_write_test_error:
    msso_printf_error(ddr_source_addr,i);
} // end function
		



// ****************************************************************************************
// *                    7400 DDR One bit Static SSO read Test                             *
// * Does a static bit read test to the 7400 Decode DDR.                                  *
// * Inputs:   none                                                                       *
// * Outputs:  none                                                                       *
// *                                                                                      *
// ****************************************************************************************
void etc_decode_static_read_test (void)
{
  char str[20];
  unsigned long decode_sso_data = 0x0000FFFF;
  unsigned long decode_sso_data2 = 0xFFFF0000;
  unsigned decode_mask = 0x00010001;
  unsigned int select_bit;
  unsigned int high_or_low;
  unsigned int done = 0;
  unsigned long ddr_source_addr = sso_test_base;
  unsigned long ddr_destination_addr = sso_test_base+SSO_BUFF;
  uint8_t *memc1_destination_addr;// = sso_test_base2;
  uint8_t *memc2_destination_addr;// = sso_test_base3;
  unsigned long i;
  unsigned char toggle = 0;
  unsigned char counter = 0;
  int len;
  unsigned int j=0;

  select_bit=__select_bit;

  //check to see if bit number is between 0 and 15
  if (select_bit<=15)
   {
  
    high_or_low=__high_or_low;

     //set masks
     decode_mask = decode_mask << select_bit;

     //check for valid selection of high or low, then mask bits
     if (high_or_low == 0)
      {
        decode_sso_data = decode_sso_data & (~decode_mask);
        decode_sso_data2 = decode_sso_data2 & (~decode_mask);
      }
     else if (high_or_low == 1)
      {
        decode_sso_data = decode_sso_data | decode_mask;
        decode_sso_data2 = decode_sso_data2 | decode_mask;
      }
     else
      {
        printf("\n Invalid Selection");/*
        BMEM_Free( b_board.b7400.memc16[0], memc1_destination_addr);
        BMEM_Free( b_board.b7400.memc16[1], memc2_destination_addr);*/
        return;
      }

    msso_printf("\netc_decode_static_read_test\n\0");

if(!uui_msso_get_status()){

  printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x500000-1);
    printf("0x%x\n",decode_sso_data);
    printf("0x%x\n",decode_sso_data2);

}else{
  memset(line,0,1024);
  sprintf(line,"testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x500000-1);
  uui_msso_printf(line);

  memset(line,0,1024);
    sprintf(line,"0x%x\n",decode_sso_data);
  uui_msso_printf(line);
  memset(line,0,1024);
    sprintf(line,"0x%x\n",decode_sso_data2);
  uui_msso_printf(line);

}
    msso_printf("0xffff0000,0x0000ffff\n");
    msso_printf("0x0000ffff,0xffff0000\n");
 for ( i=0;i<0x100000 ;i+=4 )  //generate a pattern in MEM0
       *(unsigned long*)(ddr_source_addr+i) = decode_sso_data;
     for ( i=0x100000;i<0x200000 ;i+=4 )  //generate a pattern in MEM0
       *(unsigned long*)(ddr_source_addr+i) = decode_sso_data2;
     for ( i=0x300000;i<0x400000 ;i+=8 )  //generate a pattern in MEM0
      {
        *(unsigned long*)(ddr_source_addr+i)      = 0xffff0000;
        *(unsigned long*)(ddr_source_addr+(i+4))  = 0x0000ffff;
      }
     for ( i=0x400000;i<0x500000 ;i+=8 )  //generate a pattern in MEM0
      {
        *(unsigned long*)(ddr_source_addr+i)      = 0x0000ffff;
        *(unsigned long*)(ddr_source_addr+(i+4))  = 0xffff0000;
      }    
    flush_dcache_range(ddr_source_addr,ddr_source_addr+0x500000);
    do{
    do{
    
     if(ddr_source_addr>sso_test_base){
        dma_write_long(ddr_source_addr-0x500000,ddr_source_addr,0x500000);
   if(!uui_msso_get_status()){
        printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x500000-1);
        }else{
            memset(line,0,1024);
            sprintf(line,"testing address:0x%x - 0x%x\n\0",ddr_source_addr,ddr_source_addr+0x500000-1);
            uui_msso_printf(line);
        }
    }

     for ( i=0;i<0x100000 ;i+=4 )  //generate a pattern in MEM0
       if(*(unsigned long*)(ddr_source_addr+i) != decode_sso_data) goto etc_decode_static_read_test_error;
     for ( i=0x100000;i<0x200000 ;i+=4 )  //generate a pattern in MEM0
       if(*(unsigned long*)(ddr_source_addr+i) != decode_sso_data2) goto etc_decode_static_read_test_error;
     for ( i=0x300000;i<0x400000 ;i+=8 )  //generate a pattern in MEM0
      {
        if(*(unsigned long*)(ddr_source_addr+i)      != 0xffff0000) goto etc_decode_static_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0x0000ffff) goto etc_decode_static_read_test_error;
      }
     for ( i=0x400000;i<0x500000 ;i+=8 )  //generate a pattern in MEM0
      {
        if(*(unsigned long*)(ddr_source_addr+i)      != 0x0000ffff) goto etc_decode_static_read_test_error;
        if(*(unsigned long*)(ddr_source_addr+(i+4))  != 0xffff0000) goto etc_decode_static_read_test_error;
      }
     ddr_source_addr+=0x500000;
    }while(ddr_source_addr+0x500000<sso_test_end);   
        ddr_source_addr=sso_test_base;
    }while(j++<num_trail);
   }
  else
   msso_printf(" Invalid Selection\n\0"); //bit was not between 0 and 31

    msso_printf("passed!\n");
return;
etc_decode_static_read_test_error:
    msso_printf_error(ddr_source_addr,i);
/*
  BMEM_Free( b_board.b7400.memc16[0], memc1_destination_addr);
  BMEM_Free( b_board.b7400.memc16[1], memc2_destination_addr);*/
} // end function



// ****************************************************************************************
// *                    7400 DDR One bit out of phase SSO read Test                       *
// * Does a out of phase bit read test to the 7400 Decode DDR.                            *
// * Inputs:   none                                                                       *
// * Outputs:  none                                                                       *
// *                                                                                      *
// ****************************************************************************************
void etc_decode_phase_read_test (void)
{
  char str[20];
  unsigned long decode_sso_data = 0x0000FFFF;
  unsigned long decode_sso_data2 = 0xFFFF0000;
  unsigned decode_mask = 0x00010001;
  unsigned int select_bit;
  unsigned int done = 0;
  unsigned long ddr_source_addr = sso_test_base;
  unsigned long ddr_destination_addr = sso_test_base+SSO_BUFF;
  uint8_t *memc1_destination_addr;// = sso_test_base2;
  uint8_t *memc2_destination_addr;// = sso_test_base3;
  unsigned long i;
  unsigned char toggle = 0;
  unsigned char counter = 0;
  int len;
  unsigned int j=0;
  select_bit=__select_bit;


  //check to see if bit number is between 0 and 15
  if (select_bit<=15)
   {
     //set masks
     decode_mask = decode_mask << select_bit;
     decode_sso_data = decode_sso_data & (~decode_mask);  //clear the correct bit in the FFFF portion of pattern
     decode_sso_data = decode_sso_data | (decode_mask & 0xffff0000);  //set the correct bit in the 0000 portion of pattern
     decode_sso_data2 = decode_sso_data2 & (~decode_mask);  //clear the correct bit in the FFFF portion of pattern
     decode_sso_data2 = decode_sso_data2 | (decode_mask & 0x0000ffff);  //set the correct bit in the 0000 portion of pattern

    msso_printf("etc_decode_phase_read_test\n\0");
if(!uui_msso_get_status()){

  printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x200000-1);
    printf("0x%x\n",decode_sso_data);
    printf("0x%x\n",decode_sso_data2);

}else{
  memset(line,0,1024);
  sprintf(line,"testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x200000-1);
  uui_msso_printf(line);

  memset(line,0,1024);
    sprintf(line,"0x%x\n",decode_sso_data);
  uui_msso_printf(line);
  memset(line,0,1024);
    sprintf(line,"0x%x\n",decode_sso_data2);
  uui_msso_printf(line);

}
    for ( i=0;i<0x100000 ;i+=4 )  //generate a pattern in MEM0
       *(unsigned long*)(ddr_source_addr+i) = decode_sso_data;
     for ( i=0x100000;i<0x200000 ;i+=4 )  //generate a pattern in MEM0
       *(unsigned long*)(ddr_source_addr+i) = decode_sso_data2;
    flush_dcache_range(ddr_source_addr,ddr_source_addr+0x200000);
    do{   
    do{
       if(ddr_source_addr>sso_test_base){
        dma_write_long(ddr_source_addr-0x200000,ddr_source_addr,0x200000);
   if(!uui_msso_get_status()){
        printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x200000-1);
        }else{
            memset(line,0,1024);
            sprintf(line,"testing address:0x%x - 0x%x\n\0",ddr_source_addr,ddr_source_addr+0x200000-1);
            uui_msso_printf(line);
        }
    }
    for ( i=0;i<0x100000 ;i+=4 )  //generate a pattern in MEM0
       if(*(unsigned long*)(ddr_source_addr+i) != decode_sso_data) goto etc_decode_phase_read_test_error;
     for ( i=0x100000;i<0x200000 ;i+=4 )  //generate a pattern in MEM0
       if(*(unsigned long*)(ddr_source_addr+i) != decode_sso_data2) goto etc_decode_phase_read_test_error;
  ddr_source_addr+=0x200000;
    }while(ddr_source_addr+0x200000<sso_test_end);
          ddr_source_addr = sso_test_base;
    }while(j++<num_trail);
   }
  else
   msso_printf(" Invalid Selection\n\0"); //bit was not between 0 and 31

    msso_printf("passed!\n");
return;
etc_decode_phase_read_test_error:
    msso_printf_error(ddr_source_addr,i);
  /*BMEM_Free( b_board.b7400.memc16[0], memc1_destination_addr);
  BMEM_Free( b_board.b7400.memc16[1], memc2_destination_addr);*/
} // end function


void etc_system_change(){
    char str[CFG_CBSIZE];
    int len;
    printf("enter new sso_test_base value:0x");
    len=readline(NULL);
    strcpy(str,console_buffer);
    sso_test_base=simple_strtoul(str,NULL,16);

    printf("enter new sso_test_end:0x");
    len=readline(NULL);
    strcpy(str,console_buffer);
    sso_test_end=simple_strtoul(str,NULL,16);

    printf("enter number of trail:");
    len=readline(NULL);
    strcpy(str,console_buffer);
    num_trail=simple_strtoul(str,NULL,10);

    printf("\n Enter bit to keep static: (0 - 31): ");
    len=readline(NULL);
    strcpy(str,console_buffer);
    __select_bit=simple_strtoul(str,NULL,10);

    printf("\n 1 = Keep Bit High");
    printf("\n 0 = Keep Bit Low");
    printf("\n Enter selection: ");
    len=readline(NULL);
    strcpy(str,console_buffer);
    __high_or_low=simple_strtoul(str,NULL,10);

    printf("new sso_test_base:%x sso_test_end:%x num_trail:%d\n",sso_test_base,sso_test_end,num_trail);
    printf("new select bit:%d high_or_low:%d\n",__select_bit,__high_or_low);

}

void uui_etc_system_change(){
    char tx_buf[MAX_APP_LEN];
    char rx_buf[MAX_APP_LEN];
    int rx_len=1024;
    int ret;
    PMSSO_HDR ptr_hdr=rx_buf;
    uui_msso_printf("enter new sso_test_base value:0x");
    make_pkt(tx_buf,MSSO_ASK_INPUT,NULL,0);
    ret=uui_send(APP_MSSO,tx_buf,sizeof(MSSO_HDR)+0);
    ret=uui_recv(APP_MSSO,rx_buf,&rx_len);
    sso_test_base=simple_strtoul(++ptr_hdr,NULL,16);

    uui_msso_printf("enter new sso_test_end:0x");
    ret=uui_send(APP_MSSO,tx_buf,sizeof(MSSO_HDR)+0);
    ret=uui_recv(APP_MSSO,rx_buf,&rx_len);
    sso_test_end=simple_strtoul(ptr_hdr,NULL,16);

    uui_msso_printf("enter number of trail:");
    ret=uui_send(APP_MSSO,tx_buf,sizeof(MSSO_HDR)+0);
    ret=uui_recv(APP_MSSO,rx_buf,&rx_len);
    num_trail=simple_strtoul(ptr_hdr,NULL,10);

    uui_msso_printf("\n Enter bit to keep static: (0 - 31): ");
    ret=uui_send(APP_MSSO,tx_buf,sizeof(MSSO_HDR)+0);
    ret=uui_recv(APP_MSSO,rx_buf,&rx_len);
    __select_bit=simple_strtoul(ptr_hdr,NULL,10);


    uui_msso_printf("\n 1 = Keep Bit High");
    uui_msso_printf("\n 0 = Keep Bit Low");
    uui_msso_printf("\n Enter selection: ");
    ret=uui_send(APP_MSSO,tx_buf,sizeof(MSSO_HDR)+0);
    ret=uui_recv(APP_MSSO,rx_buf,&rx_len);
    __high_or_low=simple_strtoul(ptr_hdr,NULL,10);

    memset(line,0,1024);
    sprintf(line, "new sso_test_base:%x sso_test_end:%x num_trail:%d\n",sso_test_base,sso_test_end,num_trail);
    uui_msso_printf(line);
    sprintf(line, "new select bit:%d high_or_low:%d\n",__select_bit,__high_or_low);
    memset(line,0,1024);
    uui_msso_printf(line);
}
void etc_system_walking_one(){
    unsigned int pattern=0;
    unsigned long ddr_source_addr = sso_test_base;
    int i=0;
    int j=0;
    msso_printf("etc_system_walking_one\n\0");
    do{
    do{
        if(!uui_msso_get_status()){
        printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x800000-1);
        }else{
            memset(line,0,1024);
            sprintf(line,"testing address:0x%x - 0x%x\n\0",ddr_source_addr,ddr_source_addr+0x800000-1);
            uui_msso_printf(line);
        }
    for(i=0;i<0x800000;i+=4){
        for (pattern = 1; pattern != 0; pattern <<= 1){
            *(unsigned long*)(ddr_source_addr+i)= pattern;
            if (*(unsigned long*)(ddr_source_addr+i) != pattern){
                goto etc_system_walking_one_error;
            }
        }    
    }
      ddr_source_addr+=0x800000;
    }while(ddr_source_addr+0x800000<sso_test_end);
        ddr_source_addr=sso_test_base;
    }while(j++<num_trail);
msso_printf("passed!\n\0");return;
etc_system_walking_one_error:
msso_printf_error(ddr_source_addr,i);
}

void etc_system_walking_zero(){
    unsigned int pattern=0;
    unsigned long ddr_source_addr = sso_test_base;
    int i=0;
    unsigned int j=0;
    msso_printf("etc_system_walking_zero\n\0");
    do{
    do{
 if(!uui_msso_get_status()){
        printf("testing address:0x%x - 0x%x\n",ddr_source_addr,ddr_source_addr+0x800000-1);
        }else{
            memset(line,0,1024);
            sprintf(line,"testing address:0x%x - 0x%x\n\0",ddr_source_addr,ddr_source_addr+0x800000-1);
            uui_msso_printf(line);
        }
    for(i=0;i<0x800000;i+=4){
        for (pattern = 1; pattern != 0; pattern <<= 1){
            *(unsigned long*)(ddr_source_addr+i)= ~pattern;
            if (*(unsigned long*)(ddr_source_addr+i) != ~pattern){
                goto etc_system_walking_zero_error;
            }
        }    
    }
      ddr_source_addr+=0x800000;
    }while(ddr_source_addr+0x800000<sso_test_end);
    ddr_source_addr=sso_test_base;
    }while(j++<num_trail);
msso_printf("passed!\n\0");return;
etc_system_walking_zero_error:
msso_printf_error(ddr_source_addr,i);
}


void etc_system_address(){
	unsigned int addr_mask = (sso_test_end - sso_test_base)/sizeof(vu_long) -1;
	unsigned int pattern = (vu_long) 0xaaaaaaaa;
    unsigned int anti_pattern = (vu_long) 0x55555555;
    unsigned int offset,test_offset,temp;
    unsigned long ddr_source_addr = sso_test_base;
    int j=0;
    msso_printf("etc_system_address\n\0");
    if(!uui_msso_get_status())
    printf("0x%x 0x%x\n",pattern,anti_pattern);
    else{
        memset(line,0,1024);
        sprintf(line,"0x%x 0x%x\n",pattern,anti_pattern);
        uui_msso_printf(line);
    }
    do {
		for (offset = 1; (offset & addr_mask) != 0; offset <<= 1) {
			*(unsigned long*)(ddr_source_addr+offset*4) = pattern;
		}

		/*
		 * Check for address bits stuck high.
		 */
		test_offset = 0;
		*(unsigned long*)(ddr_source_addr) = anti_pattern;

		for (offset = 1; (offset & addr_mask) != 0; offset <<= 1) {
		    temp = 	*(unsigned long*)(ddr_source_addr+offset*4);
            //printf("checking addr :%x\n",ddr_source_addr+offset*4);
		    if (temp != pattern) {
    if(!uui_msso_get_status()){
			printf ("\nFAILURE: Address bit stuck high @ 0x%.8lx:"
				" expected 0x%.8lx, actual 0x%.8lx\n",
				(ddr_source_addr+offset*4), pattern, temp);}
else{
    memset(line,0,1024);
	sprintf (line,"\nFAILURE: Address bit stuck high @ 0x%.8lx:"
				" expected 0x%.8lx, actual 0x%.8lx\n",
				(ddr_source_addr+offset*4), pattern, temp);
    uui_msso_printf(line);
}
			return 1;
		    }
        }


		*(unsigned long*)(ddr_source_addr) = pattern;
		/*
		 * Check for addr bits stuck low or shorted.
		 */
		for (test_offset = 1; (test_offset & addr_mask) != 0; test_offset <<= 1) {
            *(unsigned long*)(ddr_source_addr+test_offset*4) = anti_pattern;

		    for (offset = 1; (offset & addr_mask) != 0; offset <<= 1) {
			temp = *(unsigned long*)(ddr_source_addr+offset*4);
           // printf("checking addr :%x :%x\n",ddr_source_addr+offset, ddr_source_addr+test_offset);
			if ((temp != pattern) && (offset != test_offset)) {
			    if(!uui_msso_get_status()){
			printf ("\nFAILURE: Address bit stuck high @ 0x%.8lx:"
				" expected 0x%.8lx, actual 0x%.8lx\n",
				(ddr_source_addr+offset*4), pattern, temp);}
else{
    memset(line,0,1024);
	sprintf (line,"\nFAILURE: Address bit stuck high @ 0x%.8lx:"
				" expected 0x%.8lx, actual 0x%.8lx\n",
				(ddr_source_addr+offset*4), pattern, temp);
    uui_msso_printf(line);
}
			    return 1;
			}
		    }
		    *(unsigned long*)(ddr_source_addr+test_offset*4) = pattern;
		}
    }while(j++<num_trail);
    msso_printf("passed!\n");
}

void etc_system_all_test(){
    unsigned int j=0;
    unsigned int _num_trail=num_trail;
    num_trail=1;
    do{
       etc_system_sso_test();
       etc_system_static_write_test();
       etc_system_static_read_test();
       etc_system_phase_write_test();
       etc_system_phase_read_test();
       etc_decode_sso_test();
       etc_decode_static_write_test();
       etc_decode_static_read_test();
       etc_decode_phase_write_test();
       etc_decode_phase_read_test();
       etc_system_walking_one();
       etc_system_walking_zero();
       etc_system_address();
      }while(j++<_num_trail);
    num_trail=_num_trail;
}


// ****************************************************************************************
// *                       7400 DDR Status Print Function                                 *
// * Prints to the OSD to show the ddr test is running.                                   *
// * Inputs:   none                                                                       *
// * Outputs:  none                                                                       *
// *                                                                                      *
// ****************************************************************************************
void ddr_status_print (unsigned char counter)
{
    printf("counter:%c\n",counter);
}

int do_mem_msso (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[]){
    printf("msso cmd_msso.c\n");
    dma_init();
    sso_test_base=sso_test_base_0 + 0x80000000;
    sso_test_end=MAX_MEM + 0x80000000;
    num_trail=NUM_TRAIL;
    __select_bit=0;
    __high_or_low=0;
    etcDDR_SSOTest();
}

void msso_printf(char* str){
    if(!uui_msso_get_status())
        printf(str);
    else
        uui_msso_printf(str);
}
void msso_printf_error(int addr, int i){
    if(!uui_msso_get_status()){
        printf ("error on address:%x i:%x", addr,i);
    }else{
        memset(line,0,1024);
        sprintf("error on address:%x i:%x", addr,i);
        uui_msso_printf(line);
    }

}
U_BOOT_CMD(
	msso,    4,    1,     do_mem_msso,
	"msso   - sso RAM test\n",
);
