#include <config.h>
#ifdef VIXS_CDC
#include <common.h>
#include <command.h>
#include <ic_debug.h>
#include <if.h>
#include <linux/usb/xvdrv_if.h>
#define V_ETH "usb0"
#define RECV_SIZE 10*1024*1024
#define GET_KERNEL "USBIOCTL://GET kernel\0"
#define POST_KERNEL "USBIOCTL://POST kernel\0"
extern ulong load_addr;
struct para_open_req cmd_open;
struct para_close_req cmd_close;
struct para_send_req cmd_send;
struct para_recv_req cmd_recv;
struct ifreq ifr;
int fd;

int send_pkt(unsigned char* pkt, int len){
   int res=0;
   cmd_send.handle = cmd_open.handle;
   cmd_send.struct_size = sizeof(struct para_send_req);
   cmd_send.input_size= len;
   memcpy(cmd_open.input_buf,pkt,cmd_send.input_size);
   ifr.ifr_data = &cmd_send;
   res = ug_ioctl(fd,XVETH_CMD_SEND, &ifr);
   return res;

}
int do_usb_ioctl (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[]){

    int res=-1;
    unsigned * ptr_send=malloc(strlen(GET_KERNEL)+1);
    char *s;
    unsigned int* pint=NULL;
    unsigned int total_rx_byte;
    unsigned int rx_left;
    unsigned char* load_ptr=NULL;
    int i=0;
	/* pre-set load_addr */
	if ((s = getenv("loadaddr")) != NULL) {
		load_addr = simple_strtoul(s, NULL, 16);
	}
    switch(argc){
        case 2:
            load_addr=simple_strtoul(argv[1],NULL,16);
        break;
        default:
            //DBF("argc:%d load_addr:%x\n",argc,load_addr);
        break;
    }
    load_ptr=load_addr;
    memset(load_ptr,0xfe,RECV_SIZE);
    flush_cache(load_ptr, RECV_SIZE);

    strcpy(ptr_send,GET_KERNEL);
    memset(&cmd_open,0,sizeof(struct para_open_req));
    memset(&cmd_close,0,sizeof(struct para_send_req));
    memset(&cmd_send,0,sizeof(struct para_close_req));

  //  fd = socket(AF_INET,SOCK_DGRAM,0);
    strcpy(ifr.ifr_name, V_ETH);
    cmd_open.struct_size = sizeof(struct para_open_req);
    cmd_open.input_buf = 0xdeadbeaf;
    cmd_open.handle = 0;
    cmd_open.input_maxsize=0;
    cmd_open.type = VIXS_CDC_NP;
    ifr.ifr_data = &cmd_open;
    if(0!=ug_ioctl(fd,XVETH_CMD_OPEN, &ifr))   {
        printf("xveth open error\n");
        goto test_exit;
     }
    
    DBF("waiting host.....\n");
    //wait for POST_KERNEL
    do{
       cmd_recv.handle = cmd_open.handle;
       cmd_recv.struct_size = sizeof(struct para_recv_req);
       cmd_recv.output_buf = 0;
       ifr.ifr_data = &cmd_recv;
       res = ug_ioctl(fd,XVETH_CMD_RECV, &ifr);
       pint = (unsigned int*)cmd_recv.output_buf;
       if(pint){
        res=strcmp(pint,POST_KERNEL);
        dump_packet(cmd_recv.output_buf,32);
        DBF("%s\n",cmd_recv.output_buf);
       }else{
            res=-1;
        }   
   }while(res!=0);
    //send GET_KERNEL
    DBF("%s\n","GET_KERNEL");
   do{
    
       res = send_pkt(ptr_send,strlen(GET_KERNEL)+1);
       if(res)
            goto test_exit;
    }while(res!=0);
    DBF("%s\n","waiting file size");
    do{
       udelay(50000);
       //file size
       cmd_recv.handle = cmd_open.handle;
       cmd_recv.struct_size = sizeof(struct para_recv_req);
       ifr.ifr_data = &cmd_recv;
       res = ug_ioctl(fd,XVETH_CMD_RECV, &ifr);
       if(res!=0){
           if(i++ %200){
               printf("T");
            }
        }
    }while(res!=0);

    pint = (unsigned int*)cmd_recv.output_buf;
    if(*pint !=0xdeadbeef){
        DBF("*pint:%x\n",*pint);
        dump_packet(cmd_recv.output_buf,32);
        goto test_exit;
    }
    pint++;
    total_rx_byte =*pint;
    printf("incoming file size: %d bytes\n",total_rx_byte);
    rx_left = total_rx_byte;
    i=0;
        do
        {
            unsigned int rx_pack_len;
            unsigned int rx_pack_left;
            unsigned int write_ok;
                
            cmd_recv.handle = cmd_open.handle;
            cmd_recv.timeout= 10000; //10000ms
            cmd_recv.struct_size = sizeof(struct para_recv_req);
            //DBF("cmd_recv.struct_size:%x\n",cmd_recv.struct_size);
            ifr.ifr_data = &cmd_recv;
            res=ug_ioctl(fd,XVETH_CMD_RECV, &ifr);
            if  (res)
                continue;
            rx_pack_len = cmd_recv.output_size;
            rx_pack_left = rx_pack_len;

            memcpy(load_addr+total_rx_byte-rx_left,(void*)cmd_recv.output_buf,rx_pack_len);
            rx_left -= rx_pack_len;

            if(!(i++%80)) printf("*");


            //DBF("handle:%d rx_packet_len:%d rx_left:%d output_buf:%x\n",cmd_open.handle, rx_pack_len,rx_left,cmd_recv.output_buf);
        }while(rx_left);


    cmd_close.struct_size = sizeof(struct para_close_req);
    cmd_close.handle = cmd_open.handle;
    ifr.ifr_data = &cmd_close;
    if(0!=ug_ioctl(fd,XVETH_CMD_CLOSE, &ifr))
    {
        printf("xveth close error\n");
        //goto test_exit;
    }

    printf("\n%s\n","done");
    return 0;
test_exit:
    DBF_LOC;
    cmd_close.struct_size = sizeof(struct para_close_req);
    cmd_close.handle = cmd_open.handle;
    ifr.ifr_data = &cmd_close;
    if(0!=ug_ioctl(fd,XVETH_CMD_CLOSE, &ifr))
    {
        printf("xveth close error\n");
        //goto test_exit;
    }

}

U_BOOT_CMD(
	usbioctl,    2,    1,     do_usb_ioctl,
	"usbioctl  [loadAddress] - usb ioctl to fetch kernel image\n",
);
#endif
