#include <config.h>
#ifdef VIXS_CDC
#include <common.h>
#include <command.h>
#include <ic_debug.h>
#include <if.h>
#include <linux/usb/xvdrv_if.h>
#include "uui.h"
#define V_ETH "usb0"
#define RECV_SIZE 10*1024*1024

extern ulong load_addr;
struct para_open_req cmd_open;
struct para_close_req cmd_close;
struct para_send_req cmd_send;
struct para_recv_req cmd_recv;
struct ifreq ifr;
int fd;

int do_uui (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[]){

    int res=-1;
    unsigned char* rx_buf=malloc(MAX_BUF_LEN);
    char *s;
    unsigned int* pint=NULL;
    unsigned int total_rx_byte;
    unsigned int rx_left;
    unsigned char* load_ptr=NULL;
    int i=0;
    unsigned char* tmp=NULL;
    PUUIOCTL_HDR uui_ptr;
    
    memset(&cmd_open,0,sizeof(struct para_open_req));
    memset(&cmd_close,0,sizeof(struct para_send_req));
    memset(&cmd_send,0,sizeof(struct para_close_req));
    strcpy(ifr.ifr_name, V_ETH);
    cmd_open.struct_size = sizeof(struct para_open_req);
    cmd_open.input_buf = 0xdeadbeaf;
    cmd_open.handle = 0;
    cmd_open.input_maxsize=0;
    cmd_open.type = VIXS_CDC_NP;
    ifr.ifr_data = &cmd_open;
    if(0!=ug_ioctl(fd,XVETH_CMD_OPEN, &ifr))   {
        printf("xveth open error\n");
        goto uui_exit;
     }
    
     cmd_recv.handle = cmd_open.handle;
     cmd_recv.timeout= 100000;
     cmd_recv.struct_size = sizeof(struct para_recv_req);
     cmd_recv.output_buf = 0;

     cmd_send.handle = cmd_open.handle;
     cmd_send.struct_size = sizeof(struct para_send_req);
     cmd_send.input_buf = cmd_open.input_buf; 

     cmd_close.handle = cmd_open.handle;
     cmd_close.struct_size = sizeof(struct para_close_req);
    DBF("waiting host.....\n");

    ifr.ifr_data = &cmd_recv;

    do{ 
        //wait for HOST 1st packet
        do{
            res=ug_ioctl(fd,XVETH_CMD_RECV, &ifr);
        }while(res);
        uui_ptr=cmd_recv.output_buf;
        tmp=cmd_recv.output_buf;
        tmp+=sizeof(UUIOCTL_HDR);
        memcpy(rx_buf,tmp,cmd_recv.output_size-sizeof(UUIOCTL_HDR));

        switch(uui_ptr->application){
        case APP_BOOT_SEQ:
            bootseq(rx_buf,cmd_recv.output_size-sizeof(UUIOCTL_HDR));        
        break;
        case APP_MSSO:
            uui_msso(rx_buf,cmd_recv.output_size-sizeof(UUIOCTL_HDR));
        break;
        default:
            printf("unknown app\n");
        break;
    }}while(uui_ptr->application!=APP_BOOT_SEQ);
        
uui_exit:
    ifr.ifr_data = &cmd_close;
    if(0!=ug_ioctl(fd,XVETH_CMD_CLOSE, &ifr))   {
        printf("xveth open error\n");
        goto uui_exit;
     }
    return -1;
}


int uui_send(int app, unsigned char* pkt, int length){
    int res=0;
    unsigned char* tmp=cmd_send.input_buf;
    PUUIOCTL_HDR uui_ptr;

    if(app>=APP_INVALID||length>MAX_APP_LEN){
        return -1;
    }    
    //DBF("buf:%x pkt:%x length:%d\n",cmd_send.input_buf,pkt,length);
    uui_ptr = tmp;
    uui_ptr->application = app;
    uui_ptr->length = length;
    tmp+=sizeof(UUIOCTL_HDR);
    memcpy(tmp,pkt,length);
    cmd_send.input_size = length+sizeof(UUIOCTL_HDR);
    ifr.ifr_data = &cmd_send;
    
    do {
        res = ug_ioctl(fd,XVETH_CMD_SEND, &ifr);
        if(res){
            DBF_LOC;
            continue;
        }
    } while(res);

    return res;
}

int uui_recv(int app, unsigned char*buf, int* length){
    int res=0;
    unsigned char* tmp;
    if(app>=APP_INVALID||*length>MAX_APP_LEN){
        return -1;
    }    
    ifr.ifr_data = &cmd_recv;

    do{
        res=ug_ioctl(fd,XVETH_CMD_RECV, &ifr);
    }while(res);
    tmp=cmd_recv.output_buf;
    tmp+=sizeof(UUIOCTL_HDR);
    memcpy(buf,tmp,cmd_recv.output_size-sizeof(UUIOCTL_HDR));
    *length = cmd_recv.output_size-sizeof(UUIOCTL_HDR);
    return res;
}
U_BOOT_CMD(
	uui,    2,    1,     do_uui,
	"uui - memory test or fetch kernel image control by host\n",
);
#endif

