#include <common.h>
#include <command.h>
#include <ic_debug.h>
#include "uui.h"
#define RECV_SIZE 10*1024*1024
#define GET_KERNEL "USBIOCTL://GET kernel\0"
#define POST_KERNEL "USBIOCTL://POST kernel\0"

int bootseq (unsigned* rx_buf, int length){

    int res=-1;
    unsigned char* tx_buf=malloc(strlen(GET_KERNEL)+1);
    char *s;
    unsigned int* pint=NULL;
    unsigned int total_rx_byte;
    unsigned int rx_left;
    unsigned char* load_ptr=NULL;
    unsigned int rx_len=MAX_APP_LEN;
    unsigned int rx_pack_left;
    unsigned int rx_pack_len;
    int i=0;
	/* pre-set load_addr */
	if ((s = getenv("loadaddr")) != NULL) {
		load_addr = simple_strtoul(s, NULL, 16);
	}else{
        printf ("bootseq: loadaddr should be set !\n");
        return -1;
    }
    load_ptr=load_addr;
    memset(load_ptr,0xfe,RECV_SIZE);
    flush_cache(load_ptr, RECV_SIZE);

    strcpy(tx_buf,GET_KERNEL);
    
    DBF("recv host: %s\n", rx_buf);
    //wait for POST_KERNEL
    do{
 
        res=strcmp(rx_buf,POST_KERNEL);
        if(res){
            res=uui_recv(APP_BOOT_SEQ,rx_buf,&rx_len);
        }
   }while(res!=0);
    //send GET_KERNEL
    DBF("%s\n","GET_KERNEL");
    res = uui_send(APP_BOOT_SEQ,tx_buf,strlen(GET_KERNEL)+1);
    DBF("%s\n","waiting file size");
    do{
       udelay(50000);
       //file size
        res=uui_recv(APP_BOOT_SEQ,rx_buf,&rx_len);
       if(res!=0){
           if(i++ %200){
               printf("T");
            }
        }
    }while(res!=0);

    pint = rx_buf;
    if(*pint !=0xdeadbeef){
        DBF("*pint:%x\n",*pint);
        dump_packet(pint,32);
        goto bootseq_exit;
    }
    pint++;
    total_rx_byte =*pint;
    printf("incoming file size: %d bytes\n",total_rx_byte);
    rx_left = total_rx_byte;
    i=0;
        do
        {
            res=uui_recv(APP_BOOT_SEQ,rx_buf,&rx_len);
            if(res)            
                continue;
            rx_pack_len = rx_len;
            rx_pack_left = rx_pack_len;

            memcpy(load_addr+total_rx_byte-rx_left,rx_buf,rx_pack_len);
            rx_left -= rx_pack_len;

            if(!(i++%80)) printf("*");


            //DBF("handle:%d rx_packet_len:%d rx_left:%d output_buf:%x\n",cmd_open.handle, rx_pack_len,rx_left,cmd_recv.output_buf);
        }while(rx_left);

    printf("\n%s\n","done");
    free(tx_buf);
    return 0;
bootseq_exit:
    free(tx_buf);
    return -1;
}
