#include <common.h>
#include <command.h>
#include <ic_debug.h>
#include "uui.h"
#define NUM_PATTERNS 11
#define NUM_TRAIL 1
#define sso_test_base_0 30*1024*1024
#define MAX_MEM 256*1024*1024
#define SSO_BUFF (10*1024*1024)


void make_pkt(unsigned char* tx_buf, int command, void* data, int data_len){
    PMSSO_HDR ptr = tx_buf;
    ptr->cmd=command;
    ptr->data_len=data_len;
    if(data){
        memcpy(++ptr,data,data_len);
    }
}

extern unsigned int sso_test_base;
extern unsigned int sso_test_end;
extern unsigned int num_trail;
extern unsigned int __select_bit;
extern unsigned int __high_or_low;
unsigned char* tx_buf;
unsigned char* rx_buf;
unsigned int rx_len=MAX_APP_LEN;
unsigned int uui_msso_status=0;

void make_menu_pkt(unsigned* tx_buf,int len){
    PMSSO_HDR ptr = tx_buf;
    int data_len=0;
      memset(tx_buf,0,len);
     sprintf(ptr++,"%s sso_test_base:%x sso_test_end:%x\n number of trail:%d\n select_bit:%d high or lwo:%d\n %s","\n\n-----DDR Tests and Utilities Menu-----\n",sso_test_base,sso_test_end,num_trail,__select_bit,__high_or_low, " 0)  Exit\n 1)  System SSO standard\n 2)  System SSO 1 bit static WRITE\n 3)  System SSO 1 bit static READ\n 4)  System SSO 1 bit out of phase WRITE\n 5)  System SSO 1 bit out of phase READ\n 6)  Decode SSO standard\n 7)  Decode SSO 1 bit static WRITE\n 8)  Decode SSO 1 bit static READ\n 9)  Decode SSO 1 bit out of phase WRITE\n 10) Decode SSO 1 bit out of phase READ\n 13) walking one\n 14) walking zero\n 15) address and data bus\n 16) all test\n 20) change setting\n Choice and enter: \n");

    data_len=strlen(ptr);
//    printf("data_len:%d ptr:\n:%s\n",data_len,ptr);
    ptr--;
    ptr->cmd = MSSO_PRINTOUT;
    ptr->data_len = data_len;
    
}

void uui_etcDDR_SSOTest(void)
{
  int command_id;
  unsigned char done = 0;
  char str[CFG_CBSIZE];
  int temp_dqs;
  unsigned char dqs_value;
  static unsigned long int_val;
  static int choice;
  int len;
  int ret;

  make_pkt(tx_buf,MSSO_OK,NULL,0);
  uui_send(APP_MSSO,tx_buf,sizeof(MSSO_HDR)+0);
  while (!done)
  {
    PMSSO_HDR tx_ptr = tx_buf;
    PMSSO_HDR rx_ptr = rx_buf;
    make_menu_pkt(tx_buf,MAX_APP_LEN);
    ret=uui_send(APP_MSSO,tx_buf,sizeof(MSSO_HDR)+tx_ptr->data_len);
    make_pkt(tx_buf,MSSO_ASK_INPUT,NULL,0);
    ret=uui_send(APP_MSSO,tx_buf,sizeof(MSSO_HDR)+0);
    ret=uui_recv(APP_MSSO,rx_buf,&rx_len);
     //get the user input.  Will wait for remote or keyboard input
     //dump_packet(rx_buf,32);     
     choice=simple_strtoul(++rx_ptr,NULL,10);
     printf("choice:%d\n",choice);
     switch (choice)
      {
         case 20:
              uui_etc_system_change();
              break;
         case 16:
              etc_system_all_test(); 
              break;
         case 0:
              done = 1;
              break;

         case 1:
              etc_system_sso_test();
              break;

         case 2:
    	      etc_system_static_write_test();
              //clear_status_screen ();
              break;

         case 3:
              etc_system_static_read_test();
              //clear_status_screen ();
              break;

         case 4:
              etc_system_phase_write_test();
              //clear_status_screen ();
              break;

         case 5:
              etc_system_phase_read_test();
              //clear_status_screen ();
              break;

         case 6:
              etc_decode_sso_test();
              //clear_status_screen ();
              break;

         case 7:
	      etc_decode_static_write_test();
              //clear_status_screen ();
              break;

         case 8:
              etc_decode_static_read_test();
              //clear_status_screen ();
              break;

         case 9:
              etc_decode_phase_write_test();
              //clear_status_screen ();
              break;

         case 10:
              etc_decode_phase_read_test();
              //clear_status_screen ();
              break;              

         case 11 :
              //ddr_settings_menu_memtest();
              break;

         case 12 :
              //memtest();
              break;
         case 13:
            etc_system_walking_one();
              break;
         case 14:
            etc_system_walking_zero();
              break;
         case 15:
            etc_system_address();
              break;
         default:
            printf ("\nInvalid input.  Try again.");
            break;

      }  // end switch (input)
   }	// end while (!done)
}  // end function

int uui_msso(unsigned char* rx_buf, int length){
    PMSSO_HDR ptr_hdr=rx_buf;
    uui_msso_status=1;
    dma_init();
    sso_test_base=sso_test_base_0;
    sso_test_end=MAX_MEM;
    num_trail=NUM_TRAIL;
    __select_bit=0;
    __high_or_low=0;
    tx_buf=malloc(MAX_APP_LEN);
    rx_buf=malloc(MAX_APP_LEN);
    if(ptr_hdr->cmd == MSSO_OPEN) 
        uui_etcDDR_SSOTest();
   

    free(tx_buf);
    free(rx_buf);
    uui_msso_status=0;
}

int uui_msso_printf(char* str){
    make_pkt(tx_buf,MSSO_PRINTOUT,str,strlen(str));
    uui_send(APP_MSSO,tx_buf,sizeof(MSSO_HDR)+strlen(str));
}



int uui_msso_get_status(){
    return uui_msso_status;
}
