/*
 * ViXS System Inc. 
 * Copyright 2011-05-24
 * Emerson Chi echi@vixs.com
 */
 
#ifndef _VIXS_SECU_H
#define _VIXS_SECU_H

typedef unsigned char       uint8, *puint8;
typedef signed char         int8, *pint8;
typedef unsigned short      uint16, *puint16;
typedef signed short        int16, *pint16;
typedef unsigned long       uint32, *puint32;
typedef signed long         int32, *pint32;
typedef unsigned long long 	uint64, *puint64;
typedef signed long long 	int64, *pint64;
typedef unsigned int        *puint;
typedef signed int          *pint;
typedef void                *pvoid;
typedef volatile uint32     *pvuint32;

#define RSA1024				(1024 >> 3)
#define RSA2048				(2048 >> 3)
#define MAX_DATA_SIZE		(128 * 1024 * 1024)
#define DMA_ADDR_MASK		(0x0FFFFFFFUL)

/* 
 * pheader: ptr to image 
 * len: length of the image NOT padded 
 * Return value: 
 * 		0 - success
 *		negitive value - fail 
 *		
 */
extern int valid_single_image(uint8* const pheader, uint32 len);

/* 
 * DMA decrypt boot code in-place in shadow.  Blocks until done.
 * "direction" = 0 for decryption, "direction" = 1 for encryption
 * ONLY WORKS FOR SIZE < 64kB!!
 */
extern void aes_ecb_fb(volatile void* src, volatile void* dst, ulong size, char direction);
#endif
