#ifndef _VETH_IOCTL_H
#define _VETH_IOCTL_H

#define VIXS_CDC_MAGIC 0x5a5a5a5a
#define RECV_BUF_NUM (1<<5)
#define XVDEV_MAX_HANDLE 4
enum{
    CMD_TRX_BUF_FREE=1,
    CMD_PKT,
    CMD_PKT_ACK,
    CMD_PKT_ACK_JUST_FULL,
    CMD_PKT_DROP,
};

typedef struct _VIXS_CDC_HDR {
    unsigned int magic;
    unsigned short length;
    unsigned short reserve;
    unsigned char handle;
    unsigned char seq;
} VIXS_CDC_HDR,*PVIXS_CDC_HDR;

#define MTU_SIZE (9000)


struct ioctl_param
{
    unsigned int flag;
    unsigned int handle;
    void * send_buf;
    unsigned int max_buf_size;
    unsigned int send_buf_phy;
    unsigned int send_buf_user;
    unsigned int send_flag;
    unsigned int send_return;
    unsigned int mtu;
    unsigned int send_remain;
    void * recv_buf[RECV_BUF_NUM];
    unsigned int recv_buf_size[RECV_BUF_NUM];
    unsigned int recv_buf_phy[RECV_BUF_NUM];
    unsigned int recv_buf_user[RECV_BUF_NUM];
    unsigned int recv_head;
    unsigned int recv_tail;
    unsigned int recv_cur_addr;
    unsigned int recv_flag;
    unsigned short seq;
    unsigned short ex_seq;	 
    struct net_device* dev;	
   void* pVdev; 
};


struct _VDEV
{
    struct pci_dev			 *ppcidev;
	struct ioctl_param xvdev_ioctl_param[XVDEV_MAX_HANDLE];	
    void * private_data;
    int mtu;
#ifdef LINUX
    spinlock_t recv_lock;
#endif

    unsigned char p_type;
};
typedef struct _VDEV  VDEV, *PVDEV, VETHDEV, *PVETHDEV, VCOMMDEV, *PVCOMMDEV;

extern void xvdev_ioctl_init(PVETHDEV pVdev);
extern void xvdev_ioctl_release(PVETHDEV pVdev);
extern int xvdev_cmd_open(PVETHDEV pVdev,void *parg);
extern int xvdev_cmd_close(PVETHDEV pVdev,void *parg);
extern int xvdev_cmd_send(void* dev ,void *parg);
extern int xvdev_cmd_recv(PVETHDEV pVdev,void *parg);
extern int xvdev_get_rxbuf(PVETHDEV pVdev,unsigned int handle,unsigned recv_size,void **rxbuf);
extern void xvdev_recv_notify(PVETHDEV pVdev,unsigned int handle);
extern int xvdev_allocate_kernel_mem(PVETHDEV pVdev,void *parg);
extern int xvdev_release_kernel_mem(PVETHDEV pVdev,void *parg);
extern int xvdev_is_rx_full(PVETHDEV pVdev,void *parg,int* head);
extern int xvdev_change_mtu(PVDEV pVdev, int mtu);
extern int xvdev_is_all_rx_full(PVETHDEV pVdev);
#ifndef CDC_HOST
extern int vixs_eth_cmd(void* _dev,int cmd);
#endif

enum {
    NULL_HANDLE = 0,
    HANDLE_OPENED,
};

#endif //_VETH_IOCTL_H


