#ifndef _XVIF_H_
#define _XVIF_H_ 



#if defined(XC3ARC_BUILD) || defined(ARM11_BUILD)
#include <asm/io.h>
#endif

/*
#ifdef XCODE3
#include "jaguar.h"
#elif XCODE4
#include "eagle.h"
#else
#endif
*/

//#define V_DEBUG
//#define VIXS_VCOMM_DRV


#define VIXS_DMA_ENABLE
#include "vixsdma.h"

#define MAXVDEV 4


#ifdef V_DEBUG
#ifndef VIXS_VCOMM_DRV
#define PDEBUG(fmt, args...) printk(KERN_CRIT "VETH: " fmt, ##args)		
#else
#define PDEBUG(fmt, args...) printk(KERN_CRIT "VCOMM: " fmt, ##args)		
#endif
#else
#define PDEBUG(fmt, args...)
#endif

#define     VIXS_PCI_VENDOR_ID      0x1745

#ifdef XCODE3
#define     XCODE_PCI_DEVICE_ID     0x3000
#else
#define     XCODE_PCI_DEVICE_ID     0x4000
#endif

#define		TotalBAR			6   //Search all 6 Bars

typedef unsigned char       uint8, *puint8;
typedef signed char         int8, *pint8;
typedef unsigned short      uint16, *puint16;
typedef signed short        int16, *pint16;
typedef unsigned long       uint32, *puint32;
typedef signed long         int32, *pint32;
typedef unsigned int        *puint;
typedef signed int          *pint;
typedef void                *pvoid;
typedef volatile uint32     *pvuint32;
typedef unsigned int        uint32_ptr, *puint32_ptr;

#if defined(ARM11_BUILD)
void arm11_writel(int d, int a);
unsigned int arm11_readl(int a);

#define WRITEL(d, a)	arm11_writel( (int)d, (int)a )
#define READL(a)		arm11_readl( (a) )
#else
#define WRITEL(d, a)	writel( (d), (a) )
#define READL(a)		readl( (int *)(a) )
#endif

#define MMR_READ(reg)           READL( (int)(((PVDEV)pVdev)->pmmr + (reg)) )
#define MMR_WRITE(reg, data)        WRITEL( (data), (((PVDEV)pVdev)->pmmr + (reg)) )
#define MMFB_READ(off)                  READL( (((PVDEV)pVdev)->pmmfb + (off)) )
#define MMFB_WRITE(off, data)       do {WRITEL( (data), (((PVDEV)pVdev)->pmmfb + (off)) );  READL((((PVDEV)pVdev)->pmmfb + (off)) )}while(0)

#ifndef VIXS_VCOMM_DRV
//Virtual Eth driver
#define DRV_NAME "veth"

#ifdef XCODE3
#ifdef XC3ARC_BUILD
#define XV_INTERRUPT_MASK_REG                       XC_PROC4_PROC4_INT_MASK
#define XV_INTERRUPT_STATUS_REG                   XC_PROC4_PROC4_INT_STATUS  
#define XV_CMD_INTERRUPT_EN_MASK        XC_PROC4_PROC4_INT_MASK_INT_EN_DBG_INBOUND4_MASK
#define XV_ACK_INTERRUPT_EN_MASK        XC_PROC4_PROC4_INT_MASK_INT_EN_DBG_INBOUND1_MASK
#define XV_CMD_INTERRUPT_STATUS_MASK        XC_PROC4_PROC4_INT_STATUS_DBG_INBOUND4_MASK
#define XV_ACK_INTERRUPT_STATUS_MASK        XC_PROC4_PROC4_INT_STATUS_DBG_INBOUND1_MASK
#define XV_SEND_CMD_REG                                 XC_PROC4_DBG_OUTBOUND
#define XV_SEND_ACK_REG                                 XC_PROC4_OUTBOUND_CALL_0
#else
#define XV_INTERRUPT_MASK_REG               XC_PROC4_HOST_INT_MASK
#define XV_INTERRUPT_STATUS_REG            XC_PROC4_HOST_INT_STATUS
#define XV_CMD_INTERRUPT_EN_MASK        XC_PROC4_HOST_INT_MASK_INT_EN_OUTBOUND_DBG_MASK
#define XV_ACK_INTERRUPT_EN_MASK        XC_PROC4_HOST_INT_MASK_INT_EN_OUTBOUND_CALL0_MASK
#define XV_CMD_INTERRUPT_STATUS_MASK    XC_PROC4_HOST_INT_STATUS_OUTBOUND_DBG_MASK
#define XV_ACK_INTERRUPT_STATUS_MASK    XC_PROC4_HOST_INT_STATUS_OUTBOUND_CALL0_MASK
#define XV_SEND_CMD_REG                             XC_PROC4_DBG_INBOUND4
#define XV_SEND_ACK_REG                             XC_PROC4_DBG_INBOUND1
#endif

#else
#ifdef XC3ARC_BUILD
#define XV_INTERRUPT_MASK_REG                       XC_PROC3_PROC3_INT_MASK
#define XV_INTERRUPT_STATUS_REG                   XC_PROC3_PROC3_INT_STATUS  
#define XV_CMD_INTERRUPT_EN_MASK        XC_PROC3_PROC3_INT_MASK_INT_EN_DBG_INBOUND4_MASK
#define XV_ACK_INTERRUPT_EN_MASK        XC_PROC3_PROC3_INT_MASK_INT_EN_DBG_INBOUND1_MASK
#define XV_CMD_INTERRUPT_STATUS_MASK        XC_PROC3_PROC3_INT_STATUS_DBG_INBOUND4_MASK
#define XV_ACK_INTERRUPT_STATUS_MASK        XC_PROC3_PROC3_INT_STATUS_DBG_INBOUND1_MASK
#define XV_SEND_CMD_REG                                 XC_PROC3_DBG_OUTBOUND
#define XV_SEND_ACK_REG                                 XC_PROC3_OUTBOUND_CALL_0
#else
#define XV_INTERRUPT_MASK_REG               XC_PROC3_HOST_INT_MASK
#define XV_INTERRUPT_STATUS_REG            XC_PROC3_HOST_INT_STATUS
#define XV_CMD_INTERRUPT_EN_MASK        XC_PROC3_HOST_INT_MASK_INT_EN_OUTBOUND_DBG_MASK
#define XV_ACK_INTERRUPT_EN_MASK        XC_PROC3_HOST_INT_MASK_INT_EN_OUTBOUND_CALL0_MASK
#define XV_CMD_INTERRUPT_STATUS_MASK    XC_PROC3_HOST_INT_STATUS_OUTBOUND_DBG_MASK
#define XV_ACK_INTERRUPT_STATUS_MASK    XC_PROC3_HOST_INT_STATUS_OUTBOUND_CALL0_MASK
#define XV_SEND_CMD_REG                             XC_PROC3_DBG_INBOUND4
#define XV_SEND_ACK_REG                             XC_PROC3_DBG_INBOUND1
#endif
#endif
#else
//virtual Comm driver
#define DRV_NAME "vcomm"

#ifdef XCODE3
#ifdef XC3ARC_BUILD
#define XV_INTERRUPT_MASK_REG               XC_PROC4_PROC4_INT_MASK
#define XV_INTERRUPT_STATUS_REG           XC_PROC4_PROC4_INT_STATUS
#define XV_CMD_INTERRUPT_EN_MASK        XC_PROC4_PROC4_INT_MASK_INT_EN_DBG_INBOUND2_MASK
#define XV_ACK_INTERRUPT_EN_MASK        XC_PROC4_PROC4_INT_MASK_INT_EN_DBG_INBOUND3_MASK
#define XV_CMD_INTERRUPT_STATUS_MASK        XC_PROC4_PROC4_INT_STATUS_DBG_INBOUND2_MASK
#define XV_ACK_INTERRUPT_STATUS_MASK        XC_PROC4_PROC4_INT_STATUS_DBG_INBOUND3_MASK
#define XV_SEND_CMD_REG                                  XC_PROC3_OUTBOUND_CALL_0
#define XV_SEND_ACK_REG                                  XC_PROC3_OUTBOUND_CALL_1

#else
#define XV_INTERRUPT_MASK_REG               XC_PROC3_HOST_INT_MASK
#define XV_INTERRUPT_STATUS_REG           XC_PROC3_HOST_INT_STATUS
#define XV_CMD_INTERRUPT_EN_MASK        XC_PROC3_HOST_INT_MASK_INT_EN_OUTBOUND_CALL0_MASK
#define XV_ACK_INTERRUPT_EN_MASK        XC_PROC3_HOST_INT_MASK_INT_EN_OUTBOUND_CALL1_MASK
#define XV_CMD_INTERRUPT_STATUS_MASK    XC_PROC3_HOST_INT_STATUS_OUTBOUND_CALL0_MASK
#define XV_ACK_INTERRUPT_STATUS_MASK    XC_PROC3_HOST_INT_STATUS_OUTBOUND_CALL1_MASK
#define XV_SEND_CMD_REG                             XC_PROC4_DBG_INBOUND2
#define XV_SEND_ACK_REG                             XC_PROC4_DBG_INBOUND3
#endif

#else //XCODE3
#ifdef XC3ARC_BUILD
#define XV_INTERRUPT_MASK_REG               XC_PROC3_PROC3_INT_MASK
#define XV_INTERRUPT_STATUS_REG           XC_PROC3_PROC3_INT_STATUS
#define XV_CMD_INTERRUPT_EN_MASK        XC_PROC3_PROC3_INT_MASK_INT_EN_DBG_INBOUND2_MASK
#define XV_ACK_INTERRUPT_EN_MASK        XC_PROC3_PROC3_INT_MASK_INT_EN_DBG_INBOUND3_MASK
#define XV_CMD_INTERRUPT_STATUS_MASK        XC_PROC3_PROC3_INT_STATUS_DBG_INBOUND2_MASK
#define XV_ACK_INTERRUPT_STATUS_MASK        XC_PROC3_PROC3_INT_STATUS_DBG_INBOUND3_MASK
#define XV_SEND_CMD_REG                                  XC_PROC4_OUTBOUND_CALL_0
#define XV_SEND_ACK_REG                                  XC_PROC4_OUTBOUND_CALL_1

#else
#define XV_INTERRUPT_MASK_REG               XC_PROC4_HOST_INT_MASK
#define XV_INTERRUPT_STATUS_REG           XC_PROC4_HOST_INT_STATUS
#define XV_CMD_INTERRUPT_EN_MASK        XC_PROC4_HOST_INT_MASK_INT_EN_OUTBOUND_CALL0_MASK
#define XV_ACK_INTERRUPT_EN_MASK        XC_PROC4_HOST_INT_MASK_INT_EN_OUTBOUND_CALL1_MASK
#define XV_CMD_INTERRUPT_STATUS_MASK    XC_PROC4_HOST_INT_STATUS_OUTBOUND_CALL0_MASK
#define XV_ACK_INTERRUPT_STATUS_MASK    XC_PROC4_HOST_INT_STATUS_OUTBOUND_CALL1_MASK
#define XV_SEND_CMD_REG                             XC_PROC3_DBG_INBOUND2
#define XV_SEND_ACK_REG                             XC_PROC3_DBG_INBOUND3
#endif

#endif
#endif


#ifdef XCODE3
#ifndef VIXS_VCOMM_DRV
#define ARC_SELF_FLAG	XC_PROC4_MSG_DATA_8
#define ARC_PEER_FLAG	XC_PROC4_MSG_DATA_9
#else
#define ARC_SELF_FLAG	XC_PROC4_MSG_DATA_10
#define ARC_PEER_FLAG	XC_PROC4_MSG_DATA_11
#endif

#else

#ifndef VIXS_VCOMM_DRV
#define ARC_SELF_FLAG	XC_PROC3_MSG_DATA_8
#define ARC_PEER_FLAG	XC_PROC3_MSG_DATA_9
#else
#define ARC_SELF_FLAG	XC_PROC3_MSG_DATA_10
#define ARC_PEER_FLAG	XC_PROC3_MSG_DATA_11
#endif
#endif

#define HOST_SELF_FLAG	ARC_PEER_FLAG
#define HOST_PEER_FLAG	ARC_SELF_FLAG

//hard code the offset of IO buffer
#if 0
#define  ARC_RECV_BUF            0x1F0C0 
#define  ARC_RECV_BUFSIZE   0x10000
#define  ARC_SEND_BUF           (ARC_RECV_BUF + ARC_RECV_BUFSIZE)
#define  ARC_SEND_BUFSIZE          0x10000
#endif



#define  MAX_VETH_MTU  65536    


/* These are the flags in the statusword */
#define XVDEV_RX_INTR 0x0001
#define XVDEV_TX_INTR 0x0002

#define VDEV_START 0x55000000
#define VDEV_TAG_MASK 0xff000000
#define VDEV_UNTAG_MASK (~VDEV_TAG_MASK)
#define VDEV_IS_START(x)    (( (x) & VDEV_TAG_MASK) == VDEV_START)
#define VDEV_ISNOT_START(x)    (( (x) & VDEV_TAG_MASK) != VDEV_START)
#define VDEV_REMOVE_TAG(x) ( (x) & VDEV_UNTAG_MASK)
#define VDEV_ADD_TAG(x)  ( (x) | VDEV_START)

/* Default timeout period */
#define XVDEV_TIMEOUT    (HZ/5)   //50   /* In jiffies */

#define HW_LEN(len) ((len + 3) & 0xfffffffc )

#define VDEV_MSG_MAX 16
#define VDEV_MSG_MASK (VDEV_MSG_MAX -1)

//#define XVDEV_MAX_HANDLE 8
//#define RECV_BUF_NUM 8
#define RECV_BUF_MASK (RECV_BUF_NUM - 1)
#define XVDEV_MAX_RECV_TIMEOUT 300


#define VDEV_CMD_ACK_OK 0xdeadbeef
#define USB_Host_to_Device 0x40
#define USB_Device_to_Host 0xC0
#define USB_REGISTER_READ 13
#define USB_REGISTER_WRITE 14
#define USB_FRAMEBUFFER_READ 15
#define USB_FRAMEBUFFER_WRITE 16



typedef struct _VdevMsg
{
    uint32 cmd;
    uint32 buff_phy;
    uint32 buff_size;
    uint32 msg_data;
    
} VdevMsg,*PVdevMsg;

typedef struct _PROCCOMMSTRUCT {
    uint32	in_buffer_offset; //in buffer offset from the head of framebuffer
    uint32	in_buffer_size;
    uint32	out_buffer_offset; //in buffer offset from the head of framebuffer
    uint32	out_buffer_size;
    //uint32  in_w_reg;
    //uint32  in_r_reg;
    //uint32  out_w_reg;
    //uint32  out_r_reg;
    uint32 self_flag;
	uint32 peer_flag;

    uint32 msghead;
    uint32 msgtail;
    //spinlock_t  msglock;
    int start;

	VdevMsg vdevmsg[VDEV_MSG_MAX];
	
} PROCCOMMSTRUCT, *PPROCCOMMSTRUCT;




enum {
        CMD_NULL = 0,
        CMD_SKB,
        CMD_IOCTL,
};
#endif   //endof define _XVIF_H_
